(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){

module.exports = {
    ApiClient: require('./lib/api_client'),
    models: require('./lib/models')
};

},{"./lib/api_client":3,"./lib/models":5}],2:[function(require,module,exports){
var models = require('./models');

function AlphaApi(apiClient) {
    this.apiClient = apiClient;
}

/*
    Create a new changelist that can affect multiple files using different kinds of actions.
    If you require the ability to integrate or move, for example, you can use this method.

*/
AlphaApi.prototype.serverChangesPost = function serverChangesPost(server, changelistRequest, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = changelistRequest;
    this.apiClient.executeMethod('post', '/{server}/changes', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Submits a [p4gf_config](http://www.perforce.com/perforce/r15.1/manuals/git-fusion/chapter_dyn_ngj_3l.html#section_jgz_nz2_2j) file to create or update a repository configuration.

    If the repository does not exist or has been previously deleted, this method saves contents of the config file to a new `p4gf_config` file.
    If the repository has already been initialised, this method replaces all of the file contents of the specified repository's `p4gf_config` file.

*/
AlphaApi.prototype.serverGitFusionReposPost = function serverGitFusionReposPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/git-fusion-repos', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists all configured repositories readable by the current user.
*/
AlphaApi.prototype.serverGitFusionReposGet = function serverGitFusionReposGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/git-fusion-repos', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.GitFusionRepoId(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Deletes the repository configuration (The [p4gf_config file](http://www.perforce.com/perforce/r15.1/manuals/git-fusion/chapter_dyn_ngj_3l.html#section_jgz_nz2_2j)).
    Contents of the repository are not deleted from Perforce.

*/
AlphaApi.prototype.serverGitFusionReposRepoDelete = function serverGitFusionReposRepoDelete(server, repo, callback) {
    var query = null;
    var pathParams = {"server": server, "repo": repo};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/git-fusion-repos/{repo}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Updates values in the repository configuration.
    This method will find all specified parameters and update each value for the specified repository's configuration file.

*/
AlphaApi.prototype.serverGitFusionReposRepoPatch = function serverGitFusionReposRepoPatch(server, repo, body, callback) {
    var query = null;
    var pathParams = {"server": server, "repo": repo};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/git-fusion-repos/{repo}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Return configuration for the specified repository.
    Grabs and returns contents of the [p4gf_config](http://www.perforce.com/perforce/r15.1/manuals/git-fusion/chapter_dyn_ngj_3l.html#section_jgz_nz2_2j) file for given repository.

*/
AlphaApi.prototype.serverGitFusionReposRepoGet = function serverGitFusionReposRepoGet(server, repo, callback) {
    var query = null;
    var pathParams = {"server": server, "repo": repo};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/git-fusion-repos/{repo}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.GitFusionRepoConfig(response.body);
        callback(null, data);
    });
};
 

module.exports = AlphaApi;

},{"./models":5}],3:[function(require,module,exports){
"use strict;"

var request = require('superagent');

var AlphaApi = require("./alpha_api");
var DefaultApi = require("./default_api");

// Class constructor for the ApiClient
//
// The 'url' should indicate
//
// Options properties:
//
// - `timeout`: Defaults to 0. If nonzero, we'll set a client side timeout, in ms.
//
// Properties defined during initialization;
//
// - `basePath`, defaults to '/api/VERSION'.
function ApiClient(url, options) {
    this.url = url;
    this.basePath = '/api/2016.1.0';
    this.timeout = 0;

    Object.defineProperties(this, {
        "apiKey": {
            enumerable: true,
            writable: true
        }
    });
}

// Public method
//
// Creates a handle to the default (stable) set of methods.
ApiClient.prototype.createDefaultApi = function() {
    return new DefaultApi(this);
};

// Public method
//
// Creates a handle to the alpha (unstable) set of methods.
ApiClient.prototype.createAlphaApi = function() {
    return new AlphaApi(this);
};

// Undocumented method
ApiClient.prototype.createUrl = function createUrl(path, pathParams) {
    var url = this.url + this.basePath + path;
    if (pathParams) {
        Object.keys(pathParams).forEach(function(key) {
            url = url.replace("{" + key + "}", encodeURIComponent(pathParams[key]));
        });
    }
    return url;
};

// Undocumented method
ApiClient.prototype.executeMethod = function executeNoBody(method, path, pathParams, query, body, callback) {
    var req = request(method, this.createUrl(path, pathParams));

    if (this.apiKey) {
        req.set('Authorization', this.apiKey);
    }

    if (query) {
        var q = {};
        Object.keys(query).forEach(function(key) {
            if (query[key]) {
                q[key] = query[key];
            }
        });
        req.query(q);
    }

    req.accept('application/json');

    if (0 < this.timeout) {
        req.timeout(this.timeout);
    }

    if (body) {
        req.send(body);
    }

    req.end(callback);
};

module.exports = ApiClient;

},{"./alpha_api":2,"./default_api":4,"superagent":48}],4:[function(require,module,exports){
var models = require('./models');

function DefaultApi(apiClient) {
    this.apiClient = apiClient;
}

/*
    The list of registered p4d servers in your cluster.

    This is provided by a special set of configuration files in the system.
    For more information, consult the Helix Web Services user guide.

*/
DefaultApi.prototype.configP4dsGet = function configP4dsGet( callback) {
    var query = null;
    var pathParams = null;
    var body = null;
    this.apiClient.executeMethod('get', '/config/p4ds', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.P4dConfigId(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Logs into the primary authentication source.

    This can either be a p4d instance or Helix Cloud, depending upon the
    configuration of your Helix Web Services instance.

*/
DefaultApi.prototype.loginPost = function loginPost(loginRequest, callback) {
    var query = null;
    var pathParams = null;
    var body = loginRequest;
    this.apiClient.executeMethod('post', '/login', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.LoginResponse(response.body);
        callback(null, data);
    });
};
 /*
    A simple structure to monitor for "problems" an admin should take care of, and, report the current application version.

    This method does not require authentication.

*/
DefaultApi.prototype.statusGet = function statusGet( callback) {
    var query = null;
    var pathParams = null;
    var body = null;
    this.apiClient.executeMethod('get', '/status', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.HWSStatus(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new branch specification, like the `p4 branch` command.

*/
DefaultApi.prototype.serverBranchesPost = function serverBranchesPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/branches', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available branches in the system.
    The resources of this list are summaries of branches in the system.

*/
DefaultApi.prototype.serverBranchesGet = function serverBranchesGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/branches', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.BranchesCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the branch specification, similar to the `p4 branch -d` command.

*/
DefaultApi.prototype.serverBranchesBranchDelete = function serverBranchesBranchDelete(server, branch, callback) {
    var query = null;
    var pathParams = {"server": server, "branch": branch};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/branches/{branch}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update branch specifications, similar to the `p4 branch` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverBranchesBranchPatch = function serverBranchesBranchPatch(server, branch, body, callback) {
    var query = null;
    var pathParams = {"server": server, "branch": branch};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/branches/{branch}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the branch spec details of the particular branch.

*/
DefaultApi.prototype.serverBranchesBranchGet = function serverBranchesBranchGet(server, branch, callback) {
    var query = null;
    var pathParams = {"server": server, "branch": branch};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/branches/{branch}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.BranchCommand(response.body);
        callback(null, data);
    });
};
 /*
    Lists available changes in the system.
    The resources of this list are summaries of changes in the system.

*/
DefaultApi.prototype.serverChangesGet = function serverChangesGet(server, max, status, user, files, callback) {
    var query = {"max": max, "status": status, "user": user, "files": files};
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/changes', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.ChangesCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Returns the change spec details of the particular change.

*/
DefaultApi.prototype.serverChangesChangeGet = function serverChangesChangeGet(server, change, callback) {
    var query = null;
    var pathParams = {"server": server, "change": change};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/changes/{change}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.ChangeCommand(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new client specification, like the `p4 client` command.

*/
DefaultApi.prototype.serverClientsPost = function serverClientsPost(server, client, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = client;
    this.apiClient.executeMethod('post', '/{server}/clients', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available clients in the system.
    The resources of this list are summaries of clients in the system.

*/
DefaultApi.prototype.serverClientsGet = function serverClientsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/clients', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.ClientsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the client specification, similar to the `p4 client -d` command.

*/
DefaultApi.prototype.serverClientsClientDelete = function serverClientsClientDelete(server, client, callback) {
    var query = null;
    var pathParams = {"server": server, "client": client};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/clients/{client}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update client specifications, similar to the `p4 client` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverClientsClientPatch = function serverClientsClientPatch(server, client, body, callback) {
    var query = null;
    var pathParams = {"server": server, "client": client};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/clients/{client}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the client spec details of the particular client.

*/
DefaultApi.prototype.serverClientsClientGet = function serverClientsClientGet(server, client, callback) {
    var query = null;
    var pathParams = {"server": server, "client": client};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/clients/{client}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.ClientCommand(response.body);
        callback(null, data);
    });
};
 /*
    Execute a Perforce command that accepts input, like a spec.
    This only allows commands that have been whitelisted on your system.
    See the <<system_configuration>> section for details.

*/
DefaultApi.prototype.serverCommandsCommandPost = function serverCommandsCommandPost(server, command, arg, input, callback) {
    var query = {"arg": arg};
    var pathParams = {"server": server, "command": command};
    var body = input;
    this.apiClient.executeMethod('post', '/{server}/commands/{command}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Execute a Perforce command that requires no input.
    This only allows commands that have been whitelisted on your system.
    See the <<system_configuration>> section for details.

*/
DefaultApi.prototype.serverCommandsCommandGet = function serverCommandsCommandGet(server, command, arg, callback) {
    var query = {"arg": arg};
    var pathParams = {"server": server, "command": command};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/commands/{command}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available counters in the system.
    The resources of this list are summaries of counters in the system.

*/
DefaultApi.prototype.serverCountersGet = function serverCountersGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/counters', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.Counter(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the counter specification, similar to the `p4 counter -d` command.

*/
DefaultApi.prototype.serverCountersCounterDelete = function serverCountersCounterDelete(server, counter, callback) {
    var query = null;
    var pathParams = {"server": server, "counter": counter};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/counters/{counter}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the counter spec details of the particular counter.

*/
DefaultApi.prototype.serverCountersCounterGet = function serverCountersCounterGet(server, counter, callback) {
    var query = null;
    var pathParams = {"server": server, "counter": counter};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/counters/{counter}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.Counter(response.body);
        callback(null, data);
    });
};
 /*
    Update counter specifications, similar to the `p4 counter` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverCountersCounterPut = function serverCountersCounterPut(server, counter, body, callback) {
    var query = null;
    var pathParams = {"server": server, "counter": counter};
    var body = body;
    this.apiClient.executeMethod('put', '/{server}/counters/{counter}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Increments a numerical counter, similar to the `p4 counter -i` command.

*/
DefaultApi.prototype.serverCountersCounterIncrementPost = function serverCountersCounterIncrementPost(server, counter, callback) {
    var query = null;
    var pathParams = {"server": server, "counter": counter};
    var body = null;
    this.apiClient.executeMethod('post', '/{server}/counters/{counter}/increment', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new depot specification, like the `p4 depot` command.

*/
DefaultApi.prototype.serverDepotsPost = function serverDepotsPost(server, depot, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = depot;
    this.apiClient.executeMethod('post', '/{server}/depots', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available depots in the system.
    The resources of this list are summaries of depots in the system.

*/
DefaultApi.prototype.serverDepotsGet = function serverDepotsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/depots', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.DepotsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the depot specification, similar to the `p4 depot -d` command.

*/
DefaultApi.prototype.serverDepotsDepotDelete = function serverDepotsDepotDelete(server, depot, callback) {
    var query = null;
    var pathParams = {"server": server, "depot": depot};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/depots/{depot}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update depot specifications, similar to the `p4 depot` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverDepotsDepotPatch = function serverDepotsDepotPatch(server, depot, body, callback) {
    var query = null;
    var pathParams = {"server": server, "depot": depot};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/depots/{depot}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the depot spec details of the particular depot.

*/
DefaultApi.prototype.serverDepotsDepotGet = function serverDepotsDepotGet(server, depot, callback) {
    var query = null;
    var pathParams = {"server": server, "depot": depot};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/depots/{depot}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.DepotCommand(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new group specification, like the `p4 group` command.

*/
DefaultApi.prototype.serverGroupsPost = function serverGroupsPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/groups', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available groups in the system.
    The resources of this list are summaries of groups in the system.

*/
DefaultApi.prototype.serverGroupsGet = function serverGroupsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/groups', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.GroupsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the group specification, similar to the `p4 group -d` command.

*/
DefaultApi.prototype.serverGroupsGroupDelete = function serverGroupsGroupDelete(server, group, callback) {
    var query = null;
    var pathParams = {"server": server, "group": group};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/groups/{group}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update group specifications, similar to the `p4 group` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverGroupsGroupPatch = function serverGroupsGroupPatch(server, group, body, callback) {
    var query = null;
    var pathParams = {"server": server, "group": group};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/groups/{group}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the group spec details of the particular group.

*/
DefaultApi.prototype.serverGroupsGroupGet = function serverGroupsGroupGet(server, group, callback) {
    var query = null;
    var pathParams = {"server": server, "group": group};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/groups/{group}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.GroupCommand(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new job specification, like the `p4 job` command.

*/
DefaultApi.prototype.serverJobsPost = function serverJobsPost(server, job, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = job;
    this.apiClient.executeMethod('post', '/{server}/jobs', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available jobs in the system.
    The resources of this list are summaries of jobs in the system.

*/
DefaultApi.prototype.serverJobsGet = function serverJobsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/jobs', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.JobsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the job specification, similar to the `p4 job -d` command.

*/
DefaultApi.prototype.serverJobsJobDelete = function serverJobsJobDelete(server, job, callback) {
    var query = null;
    var pathParams = {"server": server, "job": job};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/jobs/{job}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update job specifications, similar to the `p4 job` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverJobsJobPatch = function serverJobsJobPatch(server, job, jobCommand, callback) {
    var query = null;
    var pathParams = {"server": server, "job": job};
    var body = jobCommand;
    this.apiClient.executeMethod('patch', '/{server}/jobs/{job}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the job spec details of the particular job.

*/
DefaultApi.prototype.serverJobsJobGet = function serverJobsJobGet(server, job, callback) {
    var query = null;
    var pathParams = {"server": server, "job": job};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/jobs/{job}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.JobCommand(response.body);
        callback(null, data);
    });
};
 /*
    Adds a fix record to the job for a particular changelist.

*/
DefaultApi.prototype.serverJobsJobFixesChangePost = function serverJobsJobFixesChangePost(server, job, change, status, callback) {
    var query = {"status": status};
    var pathParams = {"server": server, "job": job, "change": change};
    var body = null;
    this.apiClient.executeMethod('post', '/{server}/jobs/{job}/fixes/{change}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Removes the fix record association for the job for a particular changelist.

*/
DefaultApi.prototype.serverJobsJobFixesChangeDelete = function serverJobsJobFixesChangeDelete(server, job, change, callback) {
    var query = null;
    var pathParams = {"server": server, "job": job, "change": change};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/jobs/{job}/fixes/{change}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new label specification, like the `p4 label` command.

*/
DefaultApi.prototype.serverLabelsPost = function serverLabelsPost(server, label, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = label;
    this.apiClient.executeMethod('post', '/{server}/labels', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available labels in the system.
    The resources of this list are summaries of labels in the system.

*/
DefaultApi.prototype.serverLabelsGet = function serverLabelsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/labels', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.LabelsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the label specification, similar to the `p4 label -d` command.

*/
DefaultApi.prototype.serverLabelsLabelDelete = function serverLabelsLabelDelete(server, label, callback) {
    var query = null;
    var pathParams = {"server": server, "label": label};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/labels/{label}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update label specifications, similar to the `p4 label` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverLabelsLabelPatch = function serverLabelsLabelPatch(server, label, labelCommand, callback) {
    var query = null;
    var pathParams = {"server": server, "label": label};
    var body = labelCommand;
    this.apiClient.executeMethod('patch', '/{server}/labels/{label}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the label spec details of the particular label.

*/
DefaultApi.prototype.serverLabelsLabelGet = function serverLabelsLabelGet(server, label, callback) {
    var query = null;
    var pathParams = {"server": server, "label": label};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/labels/{label}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.LabelCommand(response.body);
        callback(null, data);
    });
};
 /*
    Logs into a Helix Versioning Engine (p4d) server.

*/
DefaultApi.prototype.serverLoginPost = function serverLoginPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/login', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.LoginResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists depots, files, and directories in the system.
    This combines the output of the `p4 depots`, `p4 dirs`, and `p4 files` commands, depending upon your path.

*/
DefaultApi.prototype.serverPathsGet = function serverPathsGet(server, path, callback) {
    var query = {"path": path};
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/paths', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.Location(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Returns a list of available protections in the system.
    The elements of this list are rows of the system's protections table.

    This method requires superuser access.

    See the output of http://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_protect.html[`p4 protect`] for more information.

*/
DefaultApi.prototype.serverProtectionsGet = function serverProtectionsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/protections', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.Protections(response.body);
        callback(null, data);
    });
};
 /*
    Updates the protections table.

    This method requires superuser access.

*/
DefaultApi.prototype.serverProtectionsPut = function serverProtectionsPut(server, protections, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = protections;
    this.apiClient.executeMethod('put', '/{server}/protections', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new server specification, like the `p4 server` command.

*/
DefaultApi.prototype.serverServersPost = function serverServersPost(server, serverCommand, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = serverCommand;
    this.apiClient.executeMethod('post', '/{server}/servers', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available servers in the system.
    The resources of this list are summaries of servers in the system.

*/
DefaultApi.prototype.serverServersGet = function serverServersGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/servers', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.ServersCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the server specification, similar to the `p4 server -d` command.

*/
DefaultApi.prototype.serverServersServerIdDelete = function serverServersServerIdDelete(server, serverId, callback) {
    var query = null;
    var pathParams = {"server": server, "serverId": serverId};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/servers/{serverId}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update server specifications, similar to the `p4 server` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverServersServerIdPatch = function serverServersServerIdPatch(server, serverId, serverCommand, callback) {
    var query = null;
    var pathParams = {"server": server, "serverId": serverId};
    var body = serverCommand;
    this.apiClient.executeMethod('patch', '/{server}/servers/{serverId}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the server spec details of the particular server.

*/
DefaultApi.prototype.serverServersServerIdGet = function serverServersServerIdGet(server, serverId, callback) {
    var query = null;
    var pathParams = {"server": server, "serverId": serverId};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/servers/{serverId}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.ServerCommand(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new stream specification, like the `p4 stream` command.

*/
DefaultApi.prototype.serverStreamsPost = function serverStreamsPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/streams', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available streams in the system.
    The resources of this list are summaries of streams in the system.

*/
DefaultApi.prototype.serverStreamsGet = function serverStreamsGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/streams', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.StreamsCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the stream specification, similar to the `p4 stream -d` command.

*/
DefaultApi.prototype.serverStreamsStreamDelete = function serverStreamsStreamDelete(server, stream, callback) {
    var query = {"stream": stream};
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/streams/stream', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update stream specifications, similar to the `p4 stream` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverStreamsStreamPatch = function serverStreamsStreamPatch(server, stream, body, callback) {
    var query = {"stream": stream};
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/streams/stream', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the stream spec details of the particular stream.

*/
DefaultApi.prototype.serverStreamsStreamGet = function serverStreamsStreamGet(server, stream, callback) {
    var query = {"stream": stream};
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/streams/stream', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.StreamCommand(response.body);
        callback(null, data);
    });
};
 /*
    Returns a list of available triggers in the system.
    The elements of this list are rows of the system's triggers table.

    This method requires superuser access.

*/
DefaultApi.prototype.serverTriggersGet = function serverTriggersGet(server, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/triggers', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.Triggers(response.body);
        callback(null, data);
    });
};
 /*
    Updates the triggers table.

    This method requires superuser access.

*/
DefaultApi.prototype.serverTriggersPut = function serverTriggersPut(server, triggers, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = triggers;
    this.apiClient.executeMethod('put', '/{server}/triggers', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Creates a new user specification, like the `p4 user` command.

*/
DefaultApi.prototype.serverUsersPost = function serverUsersPost(server, body, callback) {
    var query = null;
    var pathParams = {"server": server};
    var body = body;
    this.apiClient.executeMethod('post', '/{server}/users', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Lists available users in the system.
    The resources of this list are summaries of users in the system.

*/
DefaultApi.prototype.serverUsersGet = function serverUsersGet(server, includeService, max, callback) {
    var query = {"includeService": includeService, "max": max};
    var pathParams = {"server": server};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/users', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = null;
        if (Array.isArray(response.body)) {
            data = response.body.map(function(cur) {
                return new models.UsersCommand(cur);
            });
        } else {
            throw "Expected an array, got " + (typeof response.body);
        }
        callback(null, data);
    });
};
 /*
    Removes the user specification, similar to the `p4 user -d` command.

*/
DefaultApi.prototype.serverUsersUserDelete = function serverUsersUserDelete(server, user, callback) {
    var query = null;
    var pathParams = {"server": server, "user": user};
    var body = null;
    this.apiClient.executeMethod('delete', '/{server}/users/{user}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Update user specifications, similar to the `p4 user` command.
    Only the specified parameters in the body will be changed.

*/
DefaultApi.prototype.serverUsersUserPatch = function serverUsersUserPatch(server, user, body, callback) {
    var query = null;
    var pathParams = {"server": server, "user": user};
    var body = body;
    this.apiClient.executeMethod('patch', '/{server}/users/{user}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.CommandResponse(response.body);
        callback(null, data);
    });
};
 /*
    Returns the user spec details of the particular user.

*/
DefaultApi.prototype.serverUsersUserGet = function serverUsersUserGet(server, user, callback) {
    var query = null;
    var pathParams = {"server": server, "user": user};
    var body = null;
    this.apiClient.executeMethod('get', '/{server}/users/{user}', pathParams, query, body, function(err, response){
        if (err) {
            callback(err);
            return;
        }
        var data = new models.UserCommand(response.body);
        callback(null, data);
    });
};
 

module.exports = DefaultApi;

},{"./models":5}],5:[function(require,module,exports){
module.exports = {
    "BranchCommand": require("./models/branch_command"),
    "BranchesCommand": require("./models/branches_command"),
    "ChangeCommand": require("./models/change_command"),
    "ChangesCommand": require("./models/changes_command"),
    "ChangelistRequest": require("./models/changelist_request"),
    "ChangelistAction": require("./models/changelist_action"),
    "ClientCommand": require("./models/client_command"),
    "ClientsCommand": require("./models/clients_command"),
    "CommandResponse": require("./models/command_response"),
    "CommandRequest": require("./models/command_request"),
    "Counter": require("./models/counter"),
    "DepotCommand": require("./models/depot_command"),
    "DepotsCommand": require("./models/depots_command"),
    "DirsCommand": require("./models/dirs_command"),
    "FilesCommand": require("./models/files_command"),
    "FstatCommand": require("./models/fstat_command"),
    "GitFusionRepoId": require("./models/git_fusion_repo_id"),
    "GitFusionRepoConfig": require("./models/git_fusion_repo_config"),
    "GitFusionRepoBranchConfig": require("./models/git_fusion_repo_branch_config"),
    "GitFusionRepoGlobalOverrides": require("./models/git_fusion_repo_global_overrides"),
    "GroupCommand": require("./models/group_command"),
    "GroupsCommand": require("./models/groups_command"),
    "HWSStatus": require("./models/h_w_s_status"),
    "JobCommand": require("./models/job_command"),
    "JobsCommand": require("./models/jobs_command"),
    "LabelsCommand": require("./models/labels_command"),
    "LabelCommand": require("./models/label_command"),
    "Location": require("./models/location"),
    "LoginRequest": require("./models/login_request"),
    "ServerLoginRequest": require("./models/server_login_request"),
    "LoginResponse": require("./models/login_response"),
    "P4dConfigId": require("./models/p4d_config_id"),
    "Protections": require("./models/protections"),
    "ServersCommand": require("./models/servers_command"),
    "ServerCommand": require("./models/server_command"),
    "StreamCommand": require("./models/stream_command"),
    "StreamsCommand": require("./models/streams_command"),
    "Triggers": require("./models/triggers"),
    "UserCommand": require("./models/user_command"),
    "UsersCommand": require("./models/users_command")
};

},{"./models/branch_command":6,"./models/branches_command":7,"./models/change_command":8,"./models/changelist_action":9,"./models/changelist_request":10,"./models/changes_command":11,"./models/client_command":12,"./models/clients_command":13,"./models/command_request":14,"./models/command_response":15,"./models/counter":16,"./models/depot_command":17,"./models/depots_command":18,"./models/dirs_command":19,"./models/files_command":20,"./models/fstat_command":21,"./models/git_fusion_repo_branch_config":22,"./models/git_fusion_repo_config":23,"./models/git_fusion_repo_global_overrides":24,"./models/git_fusion_repo_id":25,"./models/group_command":26,"./models/groups_command":27,"./models/h_w_s_status":28,"./models/job_command":29,"./models/jobs_command":30,"./models/label_command":31,"./models/labels_command":32,"./models/location":33,"./models/login_request":34,"./models/login_response":35,"./models/p4d_config_id":36,"./models/protections":37,"./models/server_command":38,"./models/server_login_request":39,"./models/servers_command":40,"./models/stream_command":41,"./models/streams_command":42,"./models/triggers":43,"./models/user_command":44,"./models/users_command":45}],6:[function(require,module,exports){
/*
  Models the output of a `p4 branch` command.

  For more information see the [command reference](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_branch.html).

*/
function BranchCommand(data) {

    Object.defineProperties(this, {
        /*
          The branch name, as provided on the command line.
        */
        "branch": {
            value: data ? data.branch : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The owner of the branch mapping.
          By default, this will be set to the user who created the branch.
          This field is unimportant unless the Option: field value is locked.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the branch mapping was last accessed.
        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date the branch mapping was last changed.
        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          Either `unlocked` (the default) or `locked`.

          If `locked`, only the `Owner:` can modify the branch mapping, and the mapping can't be deleted until it is `unlocked`.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A short description of the branch's purpose.
        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          	A set of mappings from one set of files in the depot (the source files) to another set of files in the depot (the target files).
          	The view maps from one location in the depot to another; it can't refer to a client workspace.

            For example, the branch view `//depot/main/... //depot/r2.1/...` maps all the files under `//depot/main` to `//depot/r2.1`.

        */
        "view": {
            value: data ? data.view : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = BranchCommand;

},{}],7:[function(require,module,exports){
/*
  A reference to a branch mapping known to the system.

*/
function BranchesCommand(data) {

    Object.defineProperties(this, {
        /*
          The branch name, as provided on the command line.
        */
        "branch": {
            value: data ? data.branch : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The owner of the branch mapping.
          By default, this will be set to the user who created the branch.
          This field is unimportant unless the Option: field value is locked.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the branch mapping was last accessed.
        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date the branch mapping was last changed.
        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          Either `unlocked` (the default) or `locked`.

          If `locked`, only the `Owner:` can modify the branch mapping, and the mapping can't be deleted until it is `unlocked`.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A short description of the branch's purpose.
        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = BranchesCommand;

},{}],8:[function(require,module,exports){
/*
  A changelist specification.

  For more information see the [command reference](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_change.html).

*/
function ChangeCommand(data) {

    Object.defineProperties(this, {
        /*
          Contains the changelist number if editing an existing changelist, or `new` if creating a new changelist.

        */
        "change": {
            value: data ? data.change : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Name of current client workspace
        */
        "client": {
            value: data ? data.client : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Date the changelist was last modified.
        */
        "date": {
            enumerable: true,
            get: function() {
                if (data && data.date) {
                    var strVal = data.date;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          Name of the change owner.

          The owner of an empty pending changelist (that is, a pending changelist without any files in it) can transfer ownership of the changelist to another existing user either by editing this field, or by using the -U user option.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          `pending`, `shelved`, `submitted`, or `new`.
          Not editable by the user.

          The status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.

        */
        "status": {
            value: data ? data.status : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Textual description of changelist.

          If you do not have access to a restricted changelist, the description is replaced with a "no permission" message.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A list of jobs that are fixed by this changelist.

        */
        "jobs": {
            value: data ? data.jobs : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Type of change: `restricted` or `public`.

          The Type: field can be used to hide the change or its description from users.
          A shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.

          Public changes are displayed without restrictions.

          By default, changelists are public.
          A Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The list of files submitted in this changelist.

        */
        "files": {
            value: data ? data.files : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Displays the name of the user who ran the p4 fetch, p4 push, or p4 unzip command that imported this change into the server.

          This field is primarily useful for distributed versioning (DVCS) scenarios, in which changelists are copied from one server to another, and help you correlate the changelist’s basic identity as it is copied.

          In such configurations, Perforce recommends using the submit.identity configurable to enable automatic generation of changelist identities by the p4 submit.

        */
        "importedBy": {
            value: data ? data.importedBy : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Contains a label which uniquely identifies this changelist across all servers where it has been fetched, pushed, or unzipped.

          This field is primarily useful for distributed versioning (DVCS) scenarios, in which changelists are copied from one server to another, and help you correlate the changelist’s basic identity as it is copied.

          In such configurations, Perforce recommends using the submit.identity configurable to enable automatic generation of changelist identities by the p4 submit.

        */
        "identify": {
            value: data ? data.identify : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ChangeCommand;

},{}],9:[function(require,module,exports){
/*
*/
function ChangelistAction(data) {

    Object.defineProperties(this, {
        /*
          The target file path to edit.
        */
        "depotFile": {
            value: data ? data.depotFile : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For "branch" or "move" actions, this indicates the source file location.
        */
        "fromDepotFile": {
            value: data ? data.fromDepotFile : undefined,
            enumerable: true,
            writable: true
        },
        /*
          One of "upload", "branch", "move", or "delete"
        */
        "actionType": {
            value: data ? data.actionType : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Base64-encoded content
        */
        "content": {
            value: data ? data.content : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If set, we will only operate if this is the current version of the file.
        */
        "requireVersion": {
            value: data ? data.requireVersion : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ChangelistAction;

},{}],10:[function(require,module,exports){
/*
*/
function ChangelistRequest(data) {

    Object.defineProperties(this, {
        /*
        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Optional stream ID to use in case you want to edit files in a stream.
        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "actions": {
            value: data ? data.actions : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ChangelistRequest;

},{}],11:[function(require,module,exports){
/*
*/
function ChangesCommand(data) {

    Object.defineProperties(this, {
        /*
          The changelist ID
        */
        "change": {
            value: data ? data.change : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Last modification time of the changelist
        */
        "date": {
            enumerable: true,
            get: function() {
                if (data && data.date) {
                    var strVal = data.date;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The owner of the changelist
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Name of current client workspace.
        */
        "client": {
            value: data ? data.client : undefined,
            enumerable: true,
            writable: true
        },
        /*
          `pending`, `shelved`, `submitted`, or `new`.
          Not editable by the user.

          The status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.

        */
        "status": {
            value: data ? data.status : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Type of change: `restricted` or `public`.

          The Type: field can be used to hide the change or its description from users.
          A shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.

          Public changes are displayed without restrictions.

          By default, changelists are public.
          A Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Depot paths affected by this changelist
        */
        "path": {
            value: data ? data.path : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Textual description of changelist.

          If you do not have access to a restricted changelist, the description is replaced with a "no permission" message.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ChangesCommand;

},{}],12:[function(require,module,exports){
/*
  The client workspace specification and its view.

  For more information see the [command reference](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_client.html).

*/
function ClientCommand(data) {

    Object.defineProperties(this, {
        /*
          The client workspace name, as specified in the `P4CLIENT` environment variable or its equivalents.

        */
        "client": {
            value: data ? data.client : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The name of the user who owns the workspace.
          The default is the user who created the workspace.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The time the workspace specification was last modified.
        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time that the workspace was last used in any way.
          (Note: Reloading a workspace with p4 reload does not affect the access time.)

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The name of the workstation on which this workspace resides.
          If included, operations on this client workspace can be run only from this host.
          If not set, access is allowed from any host.

          The hostname must be provided exactly as it appears in the output of p4 info when run from that host.

          This field is meant to prevent accidental misuse of client workspaces on the wrong machine.
          Providing a host name does not guarantee security, because the actual value of the host name can be overridden with the -H option to any p4 command, or with the P4HOST environment variable.
          For a similar mechanism that does provide security, use the IP address restriction feature of p4 protect.

        */
        "host": {
            value: data ? data.host : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A textual description of the workspace. The default text is Created by owner.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The directory (on the local host) relative to which all the files in the `View:` are specified.
          The default is the current working directory.
          The path must be specified in local file system syntax.

          If you change this setting, you must physically relocate any files that currently reside there.
          On Windows client machines, you can specify the root as null to enable you to map files to multiple drives.

        */
        "root": {
            value: data ? data.root : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Up to two optional alternate client workspace roots.

          Perforce applications use the first of the main and alternate roots that match the application’s current working directory.
          Use the p4 info command to display the root being used.

          This enables users to use the same Perforce client workspace specification on multiple platforms, even those with different directory naming conventions.

          If you are using multiple or alternate workspace roots (the AltRoots: field), you can always tell which root is in effect by looking at the Client root: reported by p4 info.

          If you are using a Windows directory in any of your workspace roots, you must specify the Windows directory as your main workspace root and specify your other workspace roots in the AltRoots: field.

        */
        "altRoots": {
            value: data ? data.altRoots : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A set of seven switches that control particular workspace options.

          See [Usage Notes](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_client.html#p4_client.usage) for a listing of these options.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Options to govern the default behavior of p4 submit.

          * submitunchanged
          +
          All open files (with or without changes) are submitted to the depot. This is the default behavior of Perforce.

          * submitunchanged+reopen
          +
          All open files (with or without changes) are submitted to the depot, and all files are automatically reopened in the default changelist.

          * revertunchanged
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Unchanged files are reverted.

          * revertunchanged+reopen
          +
          Only those files with content, type, or resolved changes are submitted to the depot and reopened in the default changelist. Unchanged files are reverted and not reopened in the default changelist.

          * leaveunchanged
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Any unchanged files are moved to the default changelist.

          * leaveunchanged+reopen
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Unchanged files are moved to the default changelist, and changed files are reopened in the default changelist. This option is similar to submitunchanged+reopen, except that no unchanged files are submitted to the depot.

        */
        "submitOptions": {
            value: data ? data.submitOptions : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Configure carriage-return/linefeed (CR/LF) conversion.

          See [Usage Notes](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_client.html#p4_client.usage) for a listing of these options.

        */
        "lineEnd": {
            value: data ? data.lineEnd : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Associates the workspace with the specified stream.

          Perforce generates the view for stream-associated workspaces: you cannot modify it manually.

        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A changelist number that sets a back-in-time view of a stream.

          When StreamAtChange is set, running p4 sync (when called with no arguments) updates the workspace to files at this changelist revision, instead of the head revision.
          You cannot submit changes (p4 submit returns an error) when StreamAtChange is set, because the workspace view no longer reflects the current stream inheritance.

          This field is ignored unless the Stream field is also set to a valid stream.

        */
        "streamAtChange": {
            value: data ? data.streamAtChange : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If set, restricts usage of the workspace to the named server.
          If unset, use is allowed on master server and on any replicas of the master other than Edge servers.

        */
        "serverID": {
            value: data ? data.serverID : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Specifies the mappings between files in the depot and files in the workspace.
          A new view takes effect on the next p4 sync operation.

        */
        "view": {
            value: data ? data.view : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Restricts access to depot paths to a particular point in time.
          Files specified for the ChangeView field are read-only: they may be opened but not submitted.
          For example: `//depot/path/...@1000`

          Revisions of the files in the specified path will not be visible if they were submitted after the specified changelist number.
          Files matching a ChangeView path may not be submitted.

        */
        "changeView": {
            value: data ? data.changeView : undefined,
            enumerable: true,
            writable: true
        },
        /*
          By default clients are writeable.
          Specify readonly for short lived clients used in build automation scripts.
          Such clients cannot edit or submit files, but this should not be an issue in build scripts.

          Using writeable clients in build automation scripts can lead to db.have table fragmentation, which is used to track what files a client has synced.
          If you are experiencing such issues, use a read-only client instead.
          A readonly client is assigned its own personal db.have database table.
          The location of this table must first be specified by an administrator with the client.readonly.dir configurable.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ClientCommand;

},{}],13:[function(require,module,exports){
/*
*/
function ClientsCommand(data) {

    Object.defineProperties(this, {
        /*
          The client workspace name, as specified in the `P4CLIENT` environment variable or its equivalents.

        */
        "client": {
            value: data ? data.client : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The name of the user who owns the workspace.
          The default is the user who created the workspace.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The time the workspace specification was last modified.
        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time that the workspace was last used in any way.
          (Note: Reloading a workspace with p4 reload does not affect the access time.)

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The name of the workstation on which this workspace resides.
          If included, operations on this client workspace can be run only from this host.
          If not set, access is allowed from any host.

          The hostname must be provided exactly as it appears in the output of p4 info when run from that host.

          This field is meant to prevent accidental misuse of client workspaces on the wrong machine.
          Providing a host name does not guarantee security, because the actual value of the host name can be overridden with the -H option to any p4 command, or with the P4HOST environment variable.
          For a similar mechanism that does provide security, use the IP address restriction feature of p4 protect.

        */
        "host": {
            value: data ? data.host : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A textual description of the workspace. The default text is Created by owner.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The directory (on the local host) relative to which all the files in the `View:` are specified.
          The default is the current working directory.
          The path must be specified in local file system syntax.

          If you change this setting, you must physically relocate any files that currently reside there.
          On Windows client machines, you can specify the root as null to enable you to map files to multiple drives.    additionalProperties:

        */
        "root": {
            value: data ? data.root : undefined,
            enumerable: true,
            writable: true
        },
        /*
          By default clients are writeable.
          Specify readonly for short lived clients used in build automation scripts.
          Such clients cannot edit or submit files, but this should not be an issue in build scripts.

          Using writeable clients in build automation scripts can lead to db.have table fragmentation, which is used to track what files a client has synced.
          If you are experiencing such issues, use a read-only client instead.
          A readonly client is assigned its own personal db.have database table.
          The location of this table must first be specified by an administrator with the client.readonly.dir configurable.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A set of seven switches that control particular workspace options.

          See [Usage Notes](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_client.html#p4_client.usage) for a listing of these options.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Options to govern the default behavior of p4 submit.

          * submitunchanged
          +
          All open files (with or without changes) are submitted to the depot. This is the default behavior of Perforce.

          * submitunchanged+reopen
          +
          All open files (with or without changes) are submitted to the depot, and all files are automatically reopened in the default changelist.

          * revertunchanged
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Unchanged files are reverted.

          * revertunchanged+reopen
          +
          Only those files with content, type, or resolved changes are submitted to the depot and reopened in the default changelist. Unchanged files are reverted and not reopened in the default changelist.

          * leaveunchanged
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Any unchanged files are moved to the default changelist.

          * leaveunchanged+reopen
          +
          Only those files with content, type, or resolved changes are submitted to the depot. Unchanged files are moved to the default changelist, and changed files are reopened in the default changelist. This option is similar to submitunchanged+reopen, except that no unchanged files are submitted to the depot.

        */
        "submitOptions": {
            value: data ? data.submitOptions : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Configure carriage-return/linefeed (CR/LF) conversion.

          See [Usage Notes](https://www.perforce.com/perforce/doc.current/manuals/cmdref/p4_client.html#p4_client.usage) for a listing of these options.

        */
        "lineEnd": {
            value: data ? data.lineEnd : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Associates the workspace with the specified stream.

          Perforce generates the view for stream-associated workspaces: you cannot modify it manually.

        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ClientsCommand;

},{}],14:[function(require,module,exports){
/*
  A single map typically defines input to generic command methods.

*/
function CommandRequest(data) {

    Object.defineProperties(this, {
        /*
          Don't use this. It's a kludge around a bug in the Java client code generator
        */
        "object": {
            value: data ? data.object : undefined,
            enumerable: true,
            writable: true
        }
    });

    var self = this;
    var keys = Object.keys(self);
    if (data) {
        Object.keys(data).forEach(function(dataKey) {
            if (!keys.find(function(k) { return k == dataKey; })) {
                self[dataKey] = data[dataKey];
            }
        });
    }
}

module.exports = CommandRequest;

},{}],15:[function(require,module,exports){
/*
  A generic container for responses from the p4d server that we have yet to completely classify.

*/
function CommandResponse(data) {

    Object.defineProperties(this, {
        /*
          A collection of maps that have various values set by p4d.
        */
        "results": {
            value: data ? data.results : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = CommandResponse;

},{}],16:[function(require,module,exports){
/*
  A persistent variable in the server.
*/
function Counter(data) {

    Object.defineProperties(this, {
        /*
          The variable name
        */
        "counter": {
            value: data ? data.counter : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The variable value.
          Many variables are numerical in nature, which allow you to do atomic increment operations in method calls instead of having to fetch, increment, and save.

        */
        "value": {
            value: data ? data.value : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Counter;

},{}],17:[function(require,module,exports){
/*
  The depot specification, which is the shared repository Perforce stores files in.

*/
function DepotCommand(data) {

    Object.defineProperties(this, {
        /*
          The depot name.

        */
        "depot": {
            value: data ? data.depot : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The user who owns the depot.
          By default, this is the user who created the depot.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A short description of the depot’s purpose. Optional.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          `local`, `remote`, `spec`, `stream`, `unload`, `archive` or `tangent`.

          A local depot is writable, and is the default depot type.
          Files reside in the server's root directory and are managed directly by the server.

          A stream depot is also writable, but contains streams, a type of branch that includes hierarchy and policy.

          A remote depot references files that reside on other servers, and cannot be written to.

          The spec depot, if present, automatically archives edited forms.

          The unload depot, if present, holds infrequently-used metadata (about old client workspaces and labels) that has been unloaded with the p4 unload command.

          An archive depot is used in conjunction with the p4 archive and p4 restore commands to facilitate offline (or near-line) storage of infrequently-accessed revisions, typically large binaries.

          A tangent depot defines a read-only location that holds tangents created by the p4 fetch -t command.
          The tangent depot named tangent is automatically created by p4 fetch -t if one does not already exist.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If the `Type:` is `remote`, the address should be the P4PORT address of the remote server.
          If the `Type:` is local or spec, this field is ignored.

        */
        "address": {
            value: data ? data.address : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If the Type: is spec, this field holds an optional suffix for generated paths to objects in the spec depot.

          The default suffix is .p4s.
          You do not need a suffix to use the spec depot, but supplying a file extension to your Perforce server’s versioned specs enables users of GUI client software to associate Perforce specifications with a preferred text editor.
          If the Type: is local or remote, this field is ignored.

        */
        "suffix": {
            value: data ? data.suffix : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For stream depots, the optional depth to be used for stream paths in the depot, where depth specifies the number of slashes following the depot name of a stream. ]

          This field is used when streams are being created.
          The default is 1, matching the traditional stream name.
          You cannot update this value once streams or archive data exist in a depot.

        */
        "streamDepth": {
            value: data ? data.streamDepth : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If the Type: is local, spec, or archive, set the map to point to the relative location of the depot subdirectory.
          The map must contain the `...` wildcard; for example, a local depot new might have a Map: of `new/...`.

          If the Type: is remote, set the map to point to a location in the remote depot's physical namespace, for example, `//depot/new/rel2/...`.
          This directory will be the root of the local representation of the remote depot.

        */
        "map": {
            value: data ? data.map : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For spec depots, an optional description of which specs should be saved, expressed as a view.

        */
        "specMap": {
            value: data ? data.specMap : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = DepotCommand;

},{}],18:[function(require,module,exports){
/*
  A summary of depots in the system, with information provided by the `p4 depots` command.

*/
function DepotsCommand(data) {

    Object.defineProperties(this, {
        /*
          The depot name.

        */
        "depot": {
            value: data ? data.depot : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If the Type: is local, spec, or archive, set the map to point to the relative location of the depot subdirectory.
          The map must contain the `...` wildcard; for example, a local depot new might have a Map: of `new/...`.

          If the Type: is remote, set the map to point to a location in the remote depot's physical namespace, for example, `//depot/new/rel2/...`.
          This directory will be the root of the local representation of the remote depot.

        */
        "map": {
            value: data ? data.map : undefined,
            enumerable: true,
            writable: true
        },
        /*
          `local`, `remote`, `spec`, `stream`, `unload`, `archive` or `tangent`.

          A local depot is writable, and is the default depot type.
          Files reside in the server's root directory and are managed directly by the server.

          A stream depot is also writable, but contains streams, a type of branch that includes hierarchy and policy.

          A remote depot references files that reside on other servers, and cannot be written to.

          The spec depot, if present, automatically archives edited forms.

          The unload depot, if present, holds infrequently-used metadata (about old client workspaces and labels) that has been unloaded with the p4 unload command.

          An archive depot is used in conjunction with the p4 archive and p4 restore commands to facilitate offline (or near-line) storage of infrequently-accessed revisions, typically large binaries.

          A tangent depot defines a read-only location that holds tangents created by the p4 fetch -t command.
          The tangent depot named tangent is automatically created by p4 fetch -t if one does not already exist.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For stream depots, the optional depth to be used for stream paths in the depot, where depth specifies the number of slashes following the depot name of a stream. ]

          This field is used when streams are being created.
          The default is 1, matching the traditional stream name.
          You cannot update this value once streams or archive data exist in a depot.

        */
        "streamDepth": {
            value: data ? data.streamDepth : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A short description of the depot’s purpose. Optional.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = DepotsCommand;

},{}],19:[function(require,module,exports){
/*
*/
function DirsCommand(data) {

    Object.defineProperties(this, {
        /*
        */
        "dir": {
            value: data ? data.dir : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = DirsCommand;

},{}],20:[function(require,module,exports){
/*
*/
function FilesCommand(data) {

    Object.defineProperties(this, {
        /*
        */
        "depotFile": {
            value: data ? data.depotFile : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "revision": {
            value: data ? data.revision : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "change": {
            value: data ? data.change : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "action": {
            value: data ? data.action : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "time": {
            enumerable: true,
            get: function() {
                if (data && data.time) {
                    var strVal = data.time;
                    return Date.parse(strVal);
                }
            }
        },
        /*
        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = FilesCommand;

},{}],21:[function(require,module,exports){
/*
  Detailed information about each file, as provided by the `p4 fstat` command.

*/
function FstatCommand(data) {

    Object.defineProperties(this, {
        /*
          Depot path to file.
          For files containing special characters, the filename is displayed containing the ASCII expression of the character’s hexadecimal value.

        */
        "depotFile": {
            value: data ? data.depotFile : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Name in depot of moved to/from file.

        */
        "movedFile": {
            value: data ? data.movedFile : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Set to `shelved` if file is shelved.
        */
        "shelved": {
            value: data ? data.shelved : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Action taken at head revision, if in depot.

          One of: add, edit, delete, branch, move/add, move/delete, integrate, import, purge, or archive.

        */
        "headAction": {
            value: data ? data.headAction : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Head revision changelist number, if in depot.

        */
        "headChange": {
            value: data ? data.headChange : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Head revision number, if in depot.

        */
        "headRev": {
            value: data ? data.headRev : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Head revision type, if in depot.

        */
        "headType": {
            value: data ? data.headType : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Head charset, for unicode files.

        */
        "headCharset": {
            value: data ? data.headCharset : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Head revision changelist time, if in depot.
          Time is measured in seconds since 00:00:00 UTC, January 1, 1970.

        */
        "headTime": {
            enumerable: true,
            get: function() {
                if (data && data.headTime) {
                    var strVal = data.headTime;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          Head revision modification time (the time that the file was last modified on the client before submit), if in depot.

        */
        "headModTime": {
            enumerable: true,
            get: function() {
                if (data && data.headModTime) {
                    var strVal = data.headModTime;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          Head revision of moved file.

        */
        "movedRev": {
            value: data ? data.movedRev : undefined,
            enumerable: true,
            writable: true
        },
        /*
          MD5 digest of a file.

        */
        "digest": {
            value: data ? data.digest : undefined,
            enumerable: true,
            writable: true
        },
        /*
          File length in bytes.

        */
        "fileSize": {
            value: data ? data.fileSize : undefined,
            enumerable: true,
            writable: true
        },
        /*
          User who opened the file, if open.

        */
        "actionOwner": {
            value: data ? data.actionOwner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The number, if any, of resovled integration records.

        */
        "resolved": {
            value: data ? data.resolved : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The number, if any, of unresolved integration records.

        */
        "unresolved": {
            value: data ? data.unresolved : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The number, if any, of re-resolvable integration records.

        */
        "reresolvable": {
            value: data ? data.reresolvable : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For each user with the file open, the workspace and user with the open file.

        */
        "otherOpens": {
            value: data ? data.otherOpens : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For each user with the file locked, the workspace and user holding the lock.

        */
        "otherLocks": {
            value: data ? data.otherLocks : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For each user with the file open, the action taken.

        */
        "otherActions": {
            value: data ? data.otherActions : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The changelist number with this file open.

        */
        "otherChanges": {
            value: data ? data.otherChanges : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending integration action.

        */
        "resolveActions": {
            value: data ? data.resolveActions : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending base files.

        */
        "resolveBaseFiles": {
            value: data ? data.resolveBaseFiles : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending base revision numbers.

        */
        "resolveBaseRevs": {
            value: data ? data.resolveBaseRevs : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending from files.

        */
        "resolveFromFiles": {
            value: data ? data.resolveFromFiles : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending starting revisions.

        */
        "resolveStartFromRevs": {
            value: data ? data.resolveStartFromRevs : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Pending ending revisions.

        */
        "resolveEndFromRevs": {
            value: data ? data.resolveEndFromRevs : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = FstatCommand;

},{}],22:[function(require,module,exports){
/*
  Defines a unique Git Fusion branch.

*/
function GitFusionRepoBranchConfig(data) {

    Object.defineProperties(this, {
        /*
          Alphanumeric ID for the git branch.
          _Do not change this value once this repo has been cloned_.

        */
        "gitBranchId": {
            value: data ? data.gitBranchId : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines a name specified in a local repo for a Git branch.

          A valid Git branch name.
          Do not edit this value after you clone the repo.

        */
        "gitBranchName": {
            value: data ? data.gitBranchName : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines a Perforce workspace view mapping that maps Perforce depot paths (left side) to Git work tree paths (right side).

          Correctly formed mapping syntax; must not include any Perforce stream or spec depots, and all depot paths on the right side must match exactly across all branch definitions.
          You can add and remove only certain types of Perforce branches from this view after you clone the repo.

        */
        "view": {
            value: data ? data.view : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines a Perforce stream that maps to the Git branch.

          Provide a stream name using the syntax //streamdepot/mystream.
          A Git Fusion branch can be defined as a view or a stream but not both.
          If your branch is defined as stream, it can include only one stream.

        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Prohibit git pushes that introduce commits to the branch.

        */
        "readOnly": {
            value: data ? data.readOnly : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GitFusionRepoBranchConfig;

},{}],23:[function(require,module,exports){
/*
*/
function GitFusionRepoConfig(data) {

    Object.defineProperties(this, {
        /*
          The repository name, which can be path-like.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Repo description returned by the @list command.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "globalOverrides": {
            value: data ? data.globalOverrides : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "branches": {
            value: data ? data.branches : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GitFusionRepoConfig;

},{}],24:[function(require,module,exports){
/*
  A list of per-repo settings that override global settings.

*/
function GitFusionRepoGlobalOverrides(data) {

    Object.defineProperties(this, {
        /*
          Defines the default Unicode setting that Git Fusion applies to new repos.
          This setting is valid only when Git Fusion interacts with a Unicode-enabled Perforce server.

          (Defaults to `UTF-8`).

        */
        "charset": {
            value: data ? data.charset : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Allow Git users to create new repos by pushing/pulling a git url which specifies a Perforce depot path.
          This is similar to creating a repo from a p4 client.

        */
        "depotPathRepoCreationEnable": {
            value: data ? data.depotPathRepoCreationEnable : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Restrict which authenticated Git pushers are allowed to create new repos when depot-path-repo-creation-enable is enabled.

        */
        "depotPathRepoCreationP4group": {
            value: data ? data.depotPathRepoCreationP4group : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion assigns either the Git commit author or the Git pusher as the owner of a pushed change (submit).

        */
        "changeOwner": {
            value: data ? data.changeOwner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion creates a new branch of Perforce depot file hierarchy for each copied branch of Git workspace history, including Git task branches as Git Fusion anonymous branches.

        */
        "enableGitBranchCreation": {
            value: data ? data.enableGitBranchCreation : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Permits branch creation for Swarm reviews, even when enable-git-branch-creation is disabled.

        */
        "enableSwarmReviews": {
            value: data ? data.enableSwarmReviews : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion copies merge commits and displays them in Perforce as integrations between Perforce branches.

        */
        "enableGitMergeCommits": {
            value: data ? data.enableGitMergeCommits : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion allows Git submodules to be pushed to Perforce.

        */
        "enableGitSubmodules": {
            value: data ? data.enableGitSubmodules : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion evaluates both the author's and pusher's Perforce write permissions during a push or evaluates only the pusher's permissions.

        */
        "ignoreAuthorPermissions": {
            value: data ? data.ignoreAuthorPermissions : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Enables you to trigger pre-flight commit scripts that enforce local policy for Git pushes. This can be especially useful if you have Perforce submit triggers that could reject a push and damage the repository.

        */
        "preflightCommit": {
            value: data ? data.preflightCommit : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Enables you to require that Git clone, pull, or fetch requests check the Perforce protections table for the puller's read permission on the files being pulled.

        */
        "readPermissionCheck": {
            value: data ? data.readPermissionCheck : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If the Perforce service includes any changelists submitted by Git Fusion 13.2 or earlier, you can prevent unnecessary merge commits by setting this key to the number of the last changelist submitted before your site upgraded to a later version of Git Fusion.

        */
        "gitMergeAvoidanceAfterChangeNum": {
            value: data ? data.gitMergeAvoidanceAfterChangeNum : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Set the format for entering Perforce jobs in Git commit descriptions so that they are recognized by Git Fusion and appear in Perforce changelists as fixes.
          By default, job IDs whose string starts with "job" (as in job123456) are passed through to the changelist description and job field.
          Use this option if you want Git Fusion to recognize additional expressions, such as JIRA issue IDs.

        */
        "jobLookup": {
            value: data ? data.jobLookup : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Allow Git users to create new fully-populated depot branches within Perforce.

        */
        "depotBranchCreationEnable": {
            value: data ? data.depotBranchCreationEnable : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Restrict the authenticated Git pushers who are allowed to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.

        */
        "depotBranchCreationP4group": {
            value: data ? data.depotBranchCreationP4group : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Tell Git Fusion where to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.

          Default path is `//depot/[repo]/[git_branch_name]`.

        */
        "depotBranchCreationDepotPath": {
            value: data ? data.depotBranchCreationDepotPath : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Set how the depot path set in depotBranchCreationDepotPath should appear in Git.

          Enter a Perforce view specification that maps Perforce depot paths (left side) to Git work tree paths (right side).
          Perforce depot paths are relative to the root set in depotBranchCreationDepotPath.

          The default `... ...` maps every file under the depotBranchCreationDepotPath root to Git.
          Right side paths must match the right side for every other branch already defined within a repo.

        */
        "depotBranchCreationView": {
            value: data ? data.depotBranchCreationView : undefined,
            enumerable: true,
            writable: true
        },
        /*
          When Git reports a copy file action, store that action in Perforce as a p4 integ.
          Often set in tandem with enableGitFindRenames.

          No/Off/0%: Do not use Git's copy detection.
          Treat all possible file copy actions as p4 add actions.

          1%-100%: Use Git's copy detection. Value passed to git diff-tree --find-copies=n.

          Git Fusion also adds --find-copies-harder whenever adding --find-copies.

        */
        "enableGitFindCopies": {
            value: data ? data.enableGitFindCopies : undefined,
            enumerable: true,
            writable: true
        },
        /*
          When Git reports a rename (also called move) file action, store that in Perforce as a p4 move.
          Often set in tandem with enableGitFindCopies.

          `No`/`Off`/`0%`: Do not use Git's rename detection.
          Treat all possible file rename actions as independent p4 delete and p4 add actions.

          `1%`-`100%`: Use Git's rename detection.
          Value passed to git diff-tree --find-renames=n.

        */
        "enableGitFindRenames": {
            value: data ? data.enableGitFindRenames : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Enables you to convert Perforce stream import paths to Git submodules when you clone a Git Fusion repository.
          If set to Yes, you must also set either httpUrl or sshUrl.

        */
        "enableStreamImports": {
            value: data ? data.enableStreamImports : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The URL used by Git to clone a repository from Git Fusion over HTTP.
          This property is required if you want to use Perforce stream import paths as git submodules and you use HTTP(S).

        */
        "httpUrl": {
            value: data ? data.httpUrl : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The "URL" used by Git to clone a repository from Git Fusion using SSH.
          This property is required if you want to use Perforce stream import paths as git submodules and you use SSH.

        */
        "sshUrl": {
            value: data ? data.sshUrl : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines whether Git Fusion pays attention to case when matching Git user email addresses to Perforce user account email addresses during the authorization check.

        */
        "emailCaseSensitivity": {
            value: data ? data.emailCaseSensitivity : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Defines the source that Git Fusion uses to identify the Perforce user associated with a Git push.

          Defaults to `git-email`.

          Use any one of the following values:

          - `git-email`: Use the email address of the Git author to look for a Perforce user account with the same email address. Git Fusion consults the p4gf_usermap file first, and if that fails to produce a match, it scans the Perforce user table.
          - `git-user`: Use the user.name field in the Git commit. This is the part of the author field before the email address.
          - `git-email-account`: Use the account portion of the Git author's email address. If the Git author's email value is `samwise@the_shire.com`, Git Fusion uses the Perforce account samwise.

          You can also tell Git Fusion to iterate through multiple source types until it finds a matching Perforce account. Specify the source types in order of precedence, separated by commas. For example: git-user, git-email-account, git-email.

        */
        "authorSource": {
            value: data ? data.authorSource : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Natural number representing the number of megabytes of disk space that can be consumed by any single repo.
          This value does not include the spaced consumed on the Perforce server.

        */
        "limitSpaceMb": {
            value: data ? data.limitSpaceMb : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Natural number representing the maximum number of commits allowed in a single push.

        */
        "limitCommitsReceived": {
            value: data ? data.limitCommitsReceived : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Natural number representing the maximum number of files allowed in a single push.

        */
        "limitFilesReceived": {
            value: data ? data.limitFilesReceived : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Natural number representing the maximum number of megabytes allowed in a single push.

        */
        "limitMegabytesReceived": {
            value: data ? data.limitMegabytesReceived : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GitFusionRepoGlobalOverrides;

},{}],25:[function(require,module,exports){
/*
*/
function GitFusionRepoId(data) {

    Object.defineProperties(this, {
        /*
          An identifier for the repository that can be used safely within URL paths.

        */
        "id": {
            value: data ? data.id : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The repository name, which can be path-like.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GitFusionRepoId;

},{}],26:[function(require,module,exports){
/*
  Add or delete users from a group, or set the maxresults, maxscanrows, maxlocktime, and timeout limits for the members of a group.

*/
function GroupCommand(data) {

    Object.defineProperties(this, {
        /*
          The name of the group, as entered on the command line.

        */
        "group": {
            value: data ? data.group : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The maximum number of results that members of this group can access from the service from a single command.
          The default value is `unset`.

        */
        "maxResults": {
            value: data ? data.maxResults : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The maximum number of rows that members of this group can scan from the service from a single command.
          The default value is `unset`.

        */
        "maxScanRows": {
            value: data ? data.maxScanRows : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The maximum length of time (in milliseconds) that any one operation can lock any database table when scanning data.
          The default value is `unset`.

        */
        "maxLockTime": {
            value: data ? data.maxLockTime : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The maximum number of files that a member of a group can open using a single command.

        */
        "maxOpenFiles": {
            value: data ? data.maxOpenFiles : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The duration (in seconds) of the validity of a session ticket created by p4 login.
          The default value is 43,200 seconds (12 hours).
          To create a ticket that does not expire, set the Timeout: field to `unlimited`.

        */
        "timeout": {
            value: data ? data.timeout : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The length of time (in seconds) for which passwords for users in this group remain valid.
          To disable password aging, use a value of unset.

        */
        "passwordTimeout": {
            value: data ? data.passwordTimeout : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The LDAP configuration to use when populating the group’s user list from an LDAP query.

        */
        "ldapConfig": {
            value: data ? data.ldapConfig : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The LDAP query used to identify the members of the group.

        */
        "ldapSearchQuery": {
            value: data ? data.ldapSearchQuery : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The LDAP attribute that represents the user’s username.

        */
        "ldapUserAttribute": {
            value: data ? data.ldapUserAttribute : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Names of other Perforce groups.

          To add all users in a previously defined group to the group you’re presently working with, include the group name in the Subgroups: field of the p4 group form.
          Note that user and group names occupy separate namespaces, and thus, groups and users can have the same names.

          Every member of any previously defined group you list in the Subgroups: field will be a member of the group you’re now defining.

        */
        "subgroups": {
            value: data ? data.subgroups : undefined,
            enumerable: true,
            writable: true
        },
        /*
          	Names of other Perforce users.

            Group owners without super access are permitted to administer this group, provided that they use the -a option.

            Group owners are not necessarily members of a group; if a group owner is to be a member of the group, the userid must also be added to the Users: field.

            The specified owner does not have to be a Perforce user.
            You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owners": {
            value: data ? data.owners : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The Perforce usernames of the group members.

        */
        "users": {
            value: data ? data.users : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GroupCommand;

},{}],27:[function(require,module,exports){
/*
  A list of entries that can show the layout how users are associated with the different groups in the system.

*/
function GroupsCommand(data) {

    Object.defineProperties(this, {
        /*
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "group": {
            value: data ? data.group : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "isSubGroup": {
            value: data ? data.isSubGroup : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "isOwner": {
            value: data ? data.isOwner : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "isUser": {
            value: data ? data.isUser : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "maxResults": {
            value: data ? data.maxResults : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "maxScanRows": {
            value: data ? data.maxScanRows : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "maxLockTime": {
            value: data ? data.maxLockTime : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "maxOpenFiles": {
            value: data ? data.maxOpenFiles : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "timeout": {
            value: data ? data.timeout : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "passTimeout": {
            value: data ? data.passTimeout : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = GroupsCommand;

},{}],28:[function(require,module,exports){
/*
*/
function HWSStatus(data) {

    Object.defineProperties(this, {
        /*
          When "OK" the server should be considered to be operating normally
        */
        "status": {
            value: data ? data.status : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The version of Helix Web Services server.

        */
        "version": {
            value: data ? data.version : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = HWSStatus;

},{}],29:[function(require,module,exports){
/*
  A defect, enhancement request, or other job specification.

  The actual fields in a job can be edited by a superuser in your system.
  The default set of fields in a system are Job, Status, User, Date, and Description.

*/
function JobCommand(data) {

    Object.defineProperties(this, {
        /*
          The job name.
        */
        "Job": {
            value: data ? data.Job : undefined,
            enumerable: true,
            writable: true
        }
    });

    var self = this;
    var keys = Object.keys(self);
    if (data) {
        Object.keys(data).forEach(function(dataKey) {
            if (!keys.find(function(k) { return k == dataKey; })) {
                self[dataKey] = data[dataKey];
            }
        });
    }
}

module.exports = JobCommand;

},{}],30:[function(require,module,exports){
/*
  A summary of jobs in the system.

  The actual fields in a job can be edited by a superuser in your system.
  The default set of fields in a system are Job, Status, User, Date, and Description.
  Fields in the output of this command may be missing if the superuser removed User, Status, Date, or Description.

*/
function JobsCommand(data) {

    Object.defineProperties(this, {
        /*
          The job name.
        */
        "Job": {
            value: data ? data.Job : undefined,
            enumerable: true,
            writable: true
        }
    });

    var self = this;
    var keys = Object.keys(self);
    if (data) {
        Object.keys(data).forEach(function(dataKey) {
            if (!keys.find(function(k) { return k == dataKey; })) {
                self[dataKey] = data[dataKey];
            }
        });
    }
}

module.exports = JobsCommand;

},{}],31:[function(require,module,exports){
/*
  A label specification.

  Labels can be either automatic or static.
  Automatic labels refer to the revisions provided in the View: and Revision: fields.
  Static labels refer only to those specific revisions tagged by the label by means of either the p4 labelsync or p4 tag commands.

*/
function LabelCommand(data) {

    Object.defineProperties(this, {
        /*
          The label name.

        */
        "label": {
            value: data ? data.label : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The label’s owner.
          By default, the user who created the label.
          Only the owner of a label can update which files are tagged with the label.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the label specification was last modified.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time the label was last accessed, either by running p4 labelsync on the label, or by otherwise referring to a file with the label revision specifier @label.
          (Note: Reloading a label with p4 reload does not affect the access time.)

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          An optional description of the label’s purpose.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Options to control behavior and storage location of labels.

          - locked or unlocked: If the label is locked, the list of files tagged with the label cannot be changed with p4 labelsync.

          - autoreload or noautoreload. For static labels, if noautoreload is set, the label is stored in db.label, and if autoreload is set, it is stored in the unload depot. This option is ignored for automatic labels. Storing labels in the unload depot can improve performance on sites that make extremely heavy use of labels.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          An optional revision specification for an automatic label.

          If you use the # character to specify a revision number, you must use quotes around it in order to ensure that the # is parsed as a revision specifier, and not as a comment field in the form.

        */
        "revision": {
            value: data ? data.revision : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A list of depot files that can be tagged with this label.
          No files are actually tagged until `p4 labelsync` is invoked.

          Unlike client views or branch views, which map one set of files to another, label views consist of a simple list of depot files.

        */
        "view": {
            value: data ? data.view : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If set, restricts usage of the label to the named server.
          If unset, this label may be used on any server.

        */
        "serverID": {
            value: data ? data.serverID : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = LabelCommand;

},{}],32:[function(require,module,exports){
/*
*/
function LabelsCommand(data) {

    Object.defineProperties(this, {
        /*
          The label name.

        */
        "label": {
            value: data ? data.label : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the label specification was last modified.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time the label was last accessed, either by running p4 labelsync on the label, or by otherwise referring to a file with the label revision specifier @label.
          (Note: Reloading a label with p4 reload does not affect the access time.)

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The label’s owner.
          By default, the user who created the label.
          Only the owner of a label can update which files are tagged with the label.

          The specified owner does not have to be a Perforce user.
          You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Options to control behavior and storage location of labels.

          - locked or unlocked: If the label is locked, the list of files tagged with the label cannot be changed with p4 labelsync.

          - autoreload or noautoreload. For static labels, if noautoreload is set, the label is stored in db.label, and if autoreload is set, it is stored in the unload depot. This option is ignored for automatic labels. Storing labels in the unload depot can improve performance on sites that make extremely heavy use of labels.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          An optional description of the label’s purpose.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = LabelsCommand;

},{}],33:[function(require,module,exports){
/*
  A consolidated mechanism for identifying something that generally has a path in the system.

  Each location references either a depot, a dir, or a file.

*/
function Location(data) {

    Object.defineProperties(this, {
        /*
          An absolute depot path specification.
        */
        "depotPath": {
            value: data ? data.depotPath : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "depot": {
            value: data ? data.depot : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "dir": {
            value: data ? data.dir : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "file": {
            value: data ? data.file : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "fstat": {
            value: data ? data.fstat : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If this location indicates a single file, this can be set with the Base64-encoded content of the file.

        */
        "content": {
            value: data ? data.content : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Location;

},{}],34:[function(require,module,exports){
/*
  Captures the login information we need for logging into either a p4d server or our "authentication source".

*/
function LoginRequest(data) {

    Object.defineProperties(this, {
        /*
          Usually the Perforce username
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "password": {
            value: data ? data.password : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "serverLogins": {
            value: data ? data.serverLogins : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = LoginRequest;

},{}],35:[function(require,module,exports){
/*
  Either of our login methods return a ticket, which is then used as a password in a basic authentication scheme.

  When this is returned from the explicit p4d login, this is a host unlocked ticket, acceptable for using with a local client.

*/
function LoginResponse(data) {

    Object.defineProperties(this, {
        /*
        */
        "ticket": {
            value: data ? data.ticket : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = LoginResponse;

},{}],36:[function(require,module,exports){
/*
  Identification of servers the Helix Web Services instance can connect to.

*/
function P4dConfigId(data) {

    Object.defineProperties(this, {
        /*
          A simple string identifier (alphanumeric characters only, please)
        */
        "id": {
            value: data ? data.id : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A display string, not guaranteed to be unique
        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A simple textual description, for potential selection by clients.
        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = P4dConfigId;

},{}],37:[function(require,module,exports){
/*
  Displays the information stored in the `p4 protect` command.

*/
function Protections(data) {

    Object.defineProperties(this, {
        /*
          Each item in the protections array is a line in the protections table, and is split into five columns.

          1. Access level or mode.
          One of the access levels list, read, open, write, admin, super, review; or one of the rights =read, =open, =write, and =branch,

          2. Either `user` or `group`, to indicate what's identified by this entry.

          3. The group name or user name.
          To grant permission to all users, use a wildcard with just an asterix symbol.

          4. The IP address of the client host.

          5. The depot file path, which can contain wildcards.
          To exclude this mapping from the permission set, use a dash `-` as the first character of this value.

          IPv6 addresses and IPv4 addresses are also supported.
          You can use the * wildcard to refer to all IP addresses, but only when you are not using CIDR notation.

          If you use the * wildcard with an IPv6 address, you must enclose the entire IPv6 address in square brackets.
          For example, [2001:db8:1:2:*] is equivalent to [2001:db8:1:2::]/64.
          Best practice is to use CIDR notation, surround IPv6 addresses with brackets, and to avoid the * wildcard.

          How the system forms host addresses depends on the setting of the dm.proxy.protects variable.
          By default, this variable is set to 1.
          This means that if the client host uses some intermediary (proxy, broker, replica) to access the server, the proxy- prefix is prepended to the client host address to indicate that the connection is not direct.
          If you specify proxy-* for the Host field, that will affect all connections made via proxies, brokers, and replicas. A value like proxy-10.0.0.5 identifies a client machine with an IP address of 10.0.0.5 that is connected to the server through an intermediary.

          Setting the dm.proxy.protects variable to 0, removes the proxy- prefix and allows you to write a single set of protection entries that apply both to directly-connected clients as well as to those that connect via an intermediary.
          This is more convenient but less secure if it matters that a connection is made using an intermediary. If you use this setting, all intermediaries must be at release 2012.1 or higher.

        */
        "protections": {
            value: data ? data.protections : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Protections;

},{}],38:[function(require,module,exports){
/*
  The Perforce server specification describes the high-level configuration and intended usage of a Perforce server.
  For installations with only one Perforce server, the server specification is optional.

*/
function ServerCommand(data) {

    Object.defineProperties(this, {
        /*
          A unique identifier for this server.
          This must match the contents of the server’s `server.id` file as defined by the p4 serverid command.
          If the server type is identifier, the server id specifies the name of the cluster.

        */
        "serverID": {
            value: data ? data.serverID : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Server executable type.

          One of the following: `server`, `proxy`, `broker`, `identifier`, `admin`.

          Each type may offer one or more services, defined in the `services` property.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The `server` type server provides the following services:

          - standard - a standard Perforce server
          - replica - a read-only replica server
          - commit-server - central server in distributed installation
          - edge-server - node in distributed installation
          - forwarding-replica - a replica configured to forward commands that involve database writes to a master server
          - build-server - a replica that supports build automation and build farm integration
          - P4AUTH - a server that provides authentication
          - P4CHANGE - a server that provides change numbering
          - depot-master - commit-server with automated failover
          - depot-standby - standby replica of the depot-master
          - workspace-server - node in a cluster installation
          - standby - read-only replica server that uses p4 journalcopy
          - forwarding-standby - forwarding replica server that uses p4 journalcopy

          The `proxy` type server provides a p4p caching proxy.

          The `broker` type server provides the following services:

          - broker - a p4broker process
          - workspace-router - routing broker for a cluster

          The services field for the `identifier` type server specifies the existence of the cluster, and has the value `cluster`.
          The name of the cluster is then drawn from the ServerID field.

          The `admin` type server provides the following services:

          - hxca-server - the admin server for a Helix cluster.
          - zookeeper-server - ZooKeeper server for a cluster

        */
        "services": {
            value: data ? data.services : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The P4NAME associated with this server.
          You can leave this blank or you can set it to the same value as the serverid.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The P4PORT used by this server.

        */
        "address": {
            value: data ? data.address : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For an edge server, this optional field specifies the external address used for connections to a commit server.
          This field must be set for the edge server to enable parallel submits in a federated environment.

        */
        "externalAddress": {
            value: data ? data.externalAddress : undefined,
            enumerable: true,
            writable: true
        },
        /*
          An optional description for this server.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The service user name used by the server.

        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For a replica server, this optional field can contain one or more patterns describing how active client workspace metadata is to be filtered. Active client workspace data includes have lists, working records, and pending resolves.

          To include client data, use the syntax:
          `//client-pattern/...`

          To exclude client data, use the syntax:
          `-//client-pattern/...`

          All patterns are specified in client syntax.

        */
        "clientDataFilter": {
            value: data ? data.clientDataFilter : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For a replica server, this optional field can contain one or more patterns describing how submitted revision metadata is to be filtered. Submitted revision data includes revision records, integration records, label contents, and the files listed in submitted changelists.

          To include depot data, use the syntax:
          //depot/pattern/...

          To exclude depot data, use the syntax:
          -//depot/pattern/...

          All patterns are specified in depot syntax.

        */
        "revisionDataFilter": {
            value: data ? data.revisionDataFilter : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For a replica server, this optional field can contain one or more patterns describing the policy for automatically scheduling the replication of file content. If this field is present, only those files described by the pattern are automatically transferred to the replica; other files are not transferred until they are referenced by a replica command that needs the file content.

          Files specified in the ArchiveDataFilter: field are transferred to the replica regardless of whether any users of the replica have made requests for their content.

          To automatically transfer files on submit, use the syntax:
          `//depot/pattern/...`

          To exclude files from automatic transfer, use the syntax:
          `-//depot/pattern/...`

          All patterns are specified in depot syntax.

        */
        "archiveDataFilter": {
            value: data ? data.archiveDataFilter : undefined,
            enumerable: true,
            writable: true
        },
        /*
          For an edge or commit server, this optional field, which is displayed only when you use the -l or -c option, shows configuration settings for this server.

          `-l` flag shows the current configuration.
          `-c-` flag shows current configuration values, recommended default values for fields that are not set, or unset for fields that are not set and do not have default values.

          If this field is present when invoked with -c, the configuration commands in this field are run on the current server using the scope of the server specified in the serverID field.

        */
        "distributedConfig": {
            value: data ? data.distributedConfig : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ServerCommand;

},{}],39:[function(require,module,exports){
/*
*/
function ServerLoginRequest(data) {

    Object.defineProperties(this, {
        /*
          The server's ID
        */
        "id": {
            value: data ? data.id : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
        */
        "password": {
            value: data ? data.password : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ServerLoginRequest;

},{}],40:[function(require,module,exports){
/*
*/
function ServersCommand(data) {

    Object.defineProperties(this, {
        /*
          A unique identifier for this server.
          This must match the contents of the server’s `server.id` file as defined by the p4 serverid command.
          If the server type is identifier, the server id specifies the name of the cluster.

        */
        "serverID": {
            value: data ? data.serverID : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Server executable type.

          One of the following: `server`, `proxy`, `broker`, `identifier`, `admin`.

          Each type may offer one or more services, defined in the `services` property.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The `server` type server provides the following services:

          - standard - a standard Perforce server
          - replica - a read-only replica server
          - commit-server - central server in distributed installation
          - edge-server - node in distributed installation
          - forwarding-replica - a replica configured to forward commands that involve database writes to a master server
          - build-server - a replica that supports build automation and build farm integration
          - P4AUTH - a server that provides authentication
          - P4CHANGE - a server that provides change numbering
          - depot-master - commit-server with automated failover
          - depot-standby - standby replica of the depot-master
          - workspace-server - node in a cluster installation
          - standby - read-only replica server that uses p4 journalcopy
          - forwarding-standby - forwarding replica server that uses p4 journalcopy

          The `proxy` type server provides a p4p caching proxy.

          The `broker` type server provides the following services:

          - broker - a p4broker process
          - workspace-router - routing broker for a cluster

          The services field for the `identifier` type server specifies the existence of the cluster, and has the value `cluster`.
          The name of the cluster is then drawn from the ServerID field.

          The `admin` type server provides the following services:

          - hxca-server - the admin server for a Helix cluster.
          - zookeeper-server - ZooKeeper server for a cluster

        */
        "services": {
            value: data ? data.services : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The P4NAME associated with this server.
          You can leave this blank or you can set it to the same value as the serverid.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The P4PORT used by this server.

        */
        "address": {
            value: data ? data.address : undefined,
            enumerable: true,
            writable: true
        },
        /*
          An optional description for this server.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The service user name used by the server.

        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = ServersCommand;

},{}],41:[function(require,module,exports){
/*
  The Perforce stream specification defines a single stream.

  Streams are  hierarchical branches with policies that control the structure and the flow of change.
  Stream hierarchies are based on the stability of the streams, specified by the type you assign to the stream.
  Development streams are least stable (most subject to change), mainline streams are somewhat stable, and release streams are highly stable.
  Virtual streams can be used to copy and merge between parent and child streams without storing local data.
  Task streams are lightweight short-lived branches that are useful for bug fixing or new features that only modify a small subset of the branch data.

  Stream contents are defined by the paths that you map.
  By default, a stream has the same structure as its parent (the stream from which it was branched), but you can override the structure, for example to ensure that specified files cannot be submitted or integrated to other streams.

*/
function StreamCommand(data) {

    Object.defineProperties(this, {
        /*
          Specifies the stream's name (permanent identifier) and its path in the stream depot, in the form `//depotname/streamname`.

        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the stream specification was last modified.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time that the stream specification was last accessed by any Perforce command.

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The Perforce user or group who owns the stream.
          The default is the user who created the stream.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Display name of the stream.
          Unlike the Stream: field, this field can be modified.
          Defaults to the streamname portion of the stream path.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The parent of this stream.
          Must be none if the stream's `Type:` is mainline, otherwise must be set to an existing stream identifier of the form `//depotname/streamname`.

        */
        "parent": {
            value: data ? data.parent : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The stream’s type determines the expected flow of change.
          Valid stream types are `mainline`, `virtual`, `development`, and `release`.

          - `mainline`:
          The mainline stream is the parent of all streams in the stream depot. Every stream depot must have at least one mainline stream.

          - `virtual`:
          Virtual streams allow merging and copying between parent and child streams without storing local data.
          Data is passed through to the destination (a non-virtual stream) after applying restrictions on the scope of files defined in the virtual stream’s view.
          Because virtual streams do not have files in their depot namespace, it is impossible to import a virtual stream.

          - `release`:
          More stable than the mainline.
          Release streams copy from the parent and merge to the parent.

          - `development`:
          Less stable than the mainline.
          Development streams expect to merge from parent streams and copy to the parent.

          - `task`:
          Task streams are lightweight short-lived branches that are useful for bug fixing or new features that only modify a small subset of the branch data.
          Because branched (copied) files are tracked in a set of shadow tables which are later removed, repository metadata is kept to a minimum when using this type of stream.
          Workspaces associated with task streams see all branched data, but only modified and promoted data is visible to users with access to the stream’s namespace.
          The default is stream type is development.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Description of the stream.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Settings that configure stream behavior as follows:

          - `[un]locked`:
          Enable/disable other users' ability to edit or delete the stream.
          If locked, the stream specification cannot be deleted, and only its owner can modify it.
          The default is unlocked.

          - `[all,owner]submit`:
          Specifies whether all users or only the owner of the stream can submit changes to the stream.
          The default is allsubmit.
          If the Owner: of a stream marked ownersubmit is a group, all users who are members of that group can submit changes to the stream.

          - `[no]toparent`:
          Specifies whether integrations from the stream to its parent are expected.
          The default is toparent.

          - `[no]fromparent`:
          Specifies whether integrations to the stream from its parent are expected.
          The default is fromparent for mainline and development streams, and nofromparent for release streams.

          - `mergeany,mergedown`:
          Specifies whether the merge flow is restricted or whether merge is permitted from any other stream.
          For example, the mergeany option would allow a merge from a child to a parent with no warnings.
          A virtual stream must have its flow options set to notoparent and nofromparent.
          Flow options are ignored for mainline streams.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Paths define how files are incorporated into the stream structure.
          Specify paths using the following format:
          `path_type view_path [depot_path]`
          where `path_type` is a single keyword, `view_path` is a file path with no leading slashes, and the optional `depot_path` is a file path beginning with //.

          The default path is `share ...`

          Valid path types are:

          - `share view_path`:  Specified files can be synced, submitted, and integrated to and from the parent stream.

          - `isolate view_path`:  Specified files can be synced and submitted, but cannot be integrated to and from the parent stream.

          - `import view_path [depot_path]`: Specified files can be synced, but cannot be submitted or integrated to and from the parent stream.
          The `view_path` is mapped as in the parent stream's view, or to an (optional) `depot_path`.
          The `depot_path` may include a changelist specifier.
          That stream's client workspaces will be limited to seeing revisions at that change or lower within that depot path.
          For example, you can specify a depot path like this: `//depot/import/...@1000`.
          Revisions from changelists greater than 1000 will be automatically hidden from most commands.
          The changelist limits in effect for a given stream workspace are displayed in a read-only client workspace specification field called ChangeView.

          - `import+ view_path [depot_path]`:
          Functions like a standard import path, enabling you to map a path from outside the stream depot to your stream, but unlike a standard import path, you can submit changes to the files in an import+ path.

          - `exclude view_path`:
          Specified files cannot be synced, submitted or integrated to and from the parent stream.
          By default, streams inherit their structure from the parent stream (except mainlines, which have no parent).
          Paths are inherited by child stream views; a child stream’s path can downgrade the inherited view, but not upgrade it.
          (For example, a child stream can downgrade a shared path to an isolated path, but if the parent stream defines a path as isolated, its child cannot restore full access by specifying the path as shared.)
          Note that the `depot_path` is relevant only when the path_type is `import` or `import+`.

        */
        "paths": {
            value: data ? data.paths : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Reassigns the location of workspace files.
          To specify the source path and its location in the workspace, use the following syntax:
          `view_path_1 view_path_2`
          where `view_path_1` and `view_path_2` are Perforce view paths (omit leading slashes and leading or embedded wildcards; terminal wildcards are fine).
          For example, to ensure that files are synced to the local ProjectX folder, remap as follows:
          `... projectX/...`
          Line ordering in the Remapped: field is significant: if more than one line remaps the same files, the later line takes precedence.
          Remappings are inherited by child streams and the workspaces associated with them.

        */
        "remapped": {
            value: data ? data.remapped : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A list of file or directory names to be ignored in client views. For example:

          ```
          /tmp # ignores files named "tmp"
          /tmp/... # ignores directories named "tmp"
          .tmp # ignores file names ending in .tmp
          ```

          Lines in the `Ignored:` field can appear in any order.
          Ignored files and directories are inherited by child stream client views.

        */
        "ignored": {
            value: data ? data.ignored : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = StreamCommand;

},{}],42:[function(require,module,exports){
/*
  A summary of a stream in the system, as provided by the `p4 streams` command.

*/
function StreamsCommand(data) {

    Object.defineProperties(this, {
        /*
          Specifies the stream's name (permanent identifier) and its path in the stream depot, in the form `//depotname/streamname`.

        */
        "stream": {
            value: data ? data.stream : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date the stream specification was last modified.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time that the stream specification was last accessed by any Perforce command.

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The Perforce user or group who owns the stream.
          The default is the user who created the stream.

        */
        "owner": {
            value: data ? data.owner : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Display name of the stream.
          Unlike the Stream: field, this field can be modified.
          Defaults to the streamname portion of the stream path.

        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The parent of this stream.
          Must be none if the stream's `Type:` is mainline, otherwise must be set to an existing stream identifier of the form `//depotname/streamname`.

        */
        "parent": {
            value: data ? data.parent : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The stream’s type determines the expected flow of change.
          Valid stream types are `mainline`, `virtual`, `development`, and `release`.

          - `mainline`:
          The mainline stream is the parent of all streams in the stream depot. Every stream depot must have at least one mainline stream.

          - `virtual`:
          Virtual streams allow merging and copying between parent and child streams without storing local data.
          Data is passed through to the destination (a non-virtual stream) after applying restrictions on the scope of files defined in the virtual stream’s view.
          Because virtual streams do not have files in their depot namespace, it is impossible to import a virtual stream.

          - `release`:
          More stable than the mainline.
          Release streams copy from the parent and merge to the parent.

          - `development`:
          Less stable than the mainline.
          Development streams expect to merge from parent streams and copy to the parent.

          - `task`:
          Task streams are lightweight short-lived branches that are useful for bug fixing or new features that only modify a small subset of the branch data.
          Because branched (copied) files are tracked in a set of shadow tables which are later removed, repository metadata is kept to a minimum when using this type of stream.
          Workspaces associated with task streams see all branched data, but only modified and promoted data is visible to users with access to the stream’s namespace.
          The default is stream type is development.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Description of the stream.

        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Settings that configure stream behavior as follows:

          - `[un]locked`:
          Enable/disable other users' ability to edit or delete the stream.
          If locked, the stream specification cannot be deleted, and only its owner can modify it.
          The default is unlocked.

          - `[all|owner]submit`:
          Specifies whether all users or only the owner of the stream can submit changes to the stream.
          The default is allsubmit.
          If the Owner: of a stream marked ownersubmit is a group, all users who are members of that group can submit changes to the stream.

          - `[no]toparent`:
          Specifies whether integrations from the stream to its parent are expected.
          The default is toparent.

          - `[no]fromparent`:
          Specifies whether integrations to the stream from its parent are expected.
          The default is fromparent for mainline and development streams, and nofromparent for release streams.

          - `mergeany | mergedown`:
          Specifies whether the merge flow is restricted or whether merge is permitted from any other stream.
          For example, the mergeany option would allow a merge from a child to a parent with no warnings.
          A virtual stream must have its flow options set to notoparent and nofromparent.
          Flow options are ignored for mainline streams.

        */
        "options": {
            value: data ? data.options : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = StreamsCommand;

},{}],43:[function(require,module,exports){
/*
  Defines the triggers table, like it would appear in the output to the `p4 triggers` command.

*/
function Triggers(data) {

    Object.defineProperties(this, {
        /*
          A list of trigger definitions.

          A trigger definition contains four fields that specify the name of the trigger, the type of event that should trigger the execution of the script, the paths that should be affected by the trigger, the location of the script, and other trigger type-dependent information.
          When the condition specified in a trigger definition is satisfied, the associated script or program is executed.

          Example: `trig1 change-submit //depot/dir/...   "/usr/bin/s1.pl %changelist%"`

          See the Helix Versioning Engine Administrator Guide for more details on trigger definitions.

        */
        "triggers": {
            value: data ? data.triggers : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = Triggers;

},{}],44:[function(require,module,exports){
/*
  Create or edit Perforce user specifications and preferences.

  There are three types of Perforce users: standard users, operator users, and service users.
  Standard users are the default, and each standard user consumes one Perforce license.
  The operator user type is intended for system administrators; they are subject to the same restrictions on permissions as any other user, but are further restricted in that they can run only a limited subset of Perforce commands.
  Service users are intended for inter-server communication in replicated and multi-server environments, and are restricted to an even smaller subset of Perforce commands.
  Neither operators nor service users consume Perforce licenses.

*/
function UserCommand(data) {

    Object.defineProperties(this, {
        /*
          The Perforce username.
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Type of user: standard, operator, or service.

          Once you set the type, you cannot change it.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          One of the following: perforce or ldap.

          Specifying perforce enables authentication using Perforce’s internal db.user table or by way of an authentication trigger.
          This is the default unless it is overridden with the auth.default.method configurable.

          Specifying ldap enables authentication against AD/LDAP servers specified by the currently active LDAP configurations.

        */
        "authMethod": {
            value: data ? data.authMethod : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The user’s email address. By default, this is user@client.

        */
        "email": {
            value: data ? data.email : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date and time this specification was last updated.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time this user last ran a Perforce command.

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The user's full name.
        */
        "fullName": {
            value: data ? data.fullName : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Jobs matching this jobview appear on any changelists created by this user.
          Jobs that are fixed by the changelist should be left in the changelist when it's submitted with p4 submit; other jobs should be deleted from the form before submission.

        */
        "jobView": {
            value: data ? data.jobView : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The user's password.
        */
        "password": {
            value: data ? data.password : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date and time of the user’s last password change.
          If the user has no password, this field is blank.

        */
        "passwordChange": {
            enumerable: true,
            get: function() {
                if (data && data.passwordChange) {
                    var strVal = data.passwordChange;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          A list of files the user would like to review.
          This field can include exclusionary mappings.

        */
        "reviews": {
            value: data ? data.reviews : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = UserCommand;

},{}],45:[function(require,module,exports){
/*
*/
function UsersCommand(data) {

    Object.defineProperties(this, {
        /*
          The Perforce username.
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Type of user: standard, operator, or service.

          Once you set the type, you cannot change it.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The user’s email address. By default, this is user@client.

        */
        "email": {
            value: data ? data.email : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date and time this specification was last updated.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time this user last ran a Perforce command.

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The user's full name.
        */
        "fullName": {
            value: data ? data.fullName : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If 'enabled', the password has been set on the user.
        */
        "hasPassword": {
            value: data ? data.hasPassword : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = UsersCommand;

},{}],46:[function(require,module,exports){

/**
 * Expose `Emitter`.
 */

module.exports = Emitter;

/**
 * Initialize a new `Emitter`.
 *
 * @api public
 */

function Emitter(obj) {
  if (obj) return mixin(obj);
};

/**
 * Mixin the emitter properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in Emitter.prototype) {
    obj[key] = Emitter.prototype[key];
  }
  return obj;
}

/**
 * Listen on the given `event` with `fn`.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.on =
Emitter.prototype.addEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};
  (this._callbacks['$' + event] = this._callbacks['$' + event] || [])
    .push(fn);
  return this;
};

/**
 * Adds an `event` listener that will be invoked a single
 * time then automatically removed.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.once = function(event, fn){
  function on() {
    this.off(event, on);
    fn.apply(this, arguments);
  }

  on.fn = fn;
  this.on(event, on);
  return this;
};

/**
 * Remove the given callback for `event` or all
 * registered callbacks.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.off =
Emitter.prototype.removeListener =
Emitter.prototype.removeAllListeners =
Emitter.prototype.removeEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};

  // all
  if (0 == arguments.length) {
    this._callbacks = {};
    return this;
  }

  // specific event
  var callbacks = this._callbacks['$' + event];
  if (!callbacks) return this;

  // remove all handlers
  if (1 == arguments.length) {
    delete this._callbacks['$' + event];
    return this;
  }

  // remove specific handler
  var cb;
  for (var i = 0; i < callbacks.length; i++) {
    cb = callbacks[i];
    if (cb === fn || cb.fn === fn) {
      callbacks.splice(i, 1);
      break;
    }
  }
  return this;
};

/**
 * Emit `event` with the given args.
 *
 * @param {String} event
 * @param {Mixed} ...
 * @return {Emitter}
 */

Emitter.prototype.emit = function(event){
  this._callbacks = this._callbacks || {};
  var args = [].slice.call(arguments, 1)
    , callbacks = this._callbacks['$' + event];

  if (callbacks) {
    callbacks = callbacks.slice(0);
    for (var i = 0, len = callbacks.length; i < len; ++i) {
      callbacks[i].apply(this, args);
    }
  }

  return this;
};

/**
 * Return array of callbacks for `event`.
 *
 * @param {String} event
 * @return {Array}
 * @api public
 */

Emitter.prototype.listeners = function(event){
  this._callbacks = this._callbacks || {};
  return this._callbacks['$' + event] || [];
};

/**
 * Check if this emitter has `event` handlers.
 *
 * @param {String} event
 * @return {Boolean}
 * @api public
 */

Emitter.prototype.hasListeners = function(event){
  return !! this.listeners(event).length;
};

},{}],47:[function(require,module,exports){

/**
 * Reduce `arr` with `fn`.
 *
 * @param {Array} arr
 * @param {Function} fn
 * @param {Mixed} initial
 *
 * TODO: combatible error handling?
 */

module.exports = function(arr, fn, initial){  
  var idx = 0;
  var len = arr.length;
  var curr = arguments.length == 3
    ? initial
    : arr[idx++];

  while (idx < len) {
    curr = fn.call(null, curr, arr[idx], ++idx, arr);
  }
  
  return curr;
};
},{}],48:[function(require,module,exports){
/**
 * Module dependencies.
 */

var Emitter = require('emitter');
var reduce = require('reduce');
var requestBase = require('./request-base');
var isObject = require('./is-object');

/**
 * Root reference for iframes.
 */

var root;
if (typeof window !== 'undefined') { // Browser window
  root = window;
} else if (typeof self !== 'undefined') { // Web Worker
  root = self;
} else { // Other environments
  root = this;
}

/**
 * Noop.
 */

function noop(){};

/**
 * Check if `obj` is a host object,
 * we don't want to serialize these :)
 *
 * TODO: future proof, move to compoent land
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */

function isHost(obj) {
  var str = {}.toString.call(obj);

  switch (str) {
    case '[object File]':
    case '[object Blob]':
    case '[object FormData]':
      return true;
    default:
      return false;
  }
}

/**
 * Expose `request`.
 */

var request = module.exports = require('./request').bind(null, Request);

/**
 * Determine XHR.
 */

request.getXHR = function () {
  if (root.XMLHttpRequest
      && (!root.location || 'file:' != root.location.protocol
          || !root.ActiveXObject)) {
    return new XMLHttpRequest;
  } else {
    try { return new ActiveXObject('Microsoft.XMLHTTP'); } catch(e) {}
    try { return new ActiveXObject('Msxml2.XMLHTTP.6.0'); } catch(e) {}
    try { return new ActiveXObject('Msxml2.XMLHTTP.3.0'); } catch(e) {}
    try { return new ActiveXObject('Msxml2.XMLHTTP'); } catch(e) {}
  }
  return false;
};

/**
 * Removes leading and trailing whitespace, added to support IE.
 *
 * @param {String} s
 * @return {String}
 * @api private
 */

var trim = ''.trim
  ? function(s) { return s.trim(); }
  : function(s) { return s.replace(/(^\s*|\s*$)/g, ''); };

/**
 * Serialize the given `obj`.
 *
 * @param {Object} obj
 * @return {String}
 * @api private
 */

function serialize(obj) {
  if (!isObject(obj)) return obj;
  var pairs = [];
  for (var key in obj) {
    if (null != obj[key]) {
      pushEncodedKeyValuePair(pairs, key, obj[key]);
        }
      }
  return pairs.join('&');
}

/**
 * Helps 'serialize' with serializing arrays.
 * Mutates the pairs array.
 *
 * @param {Array} pairs
 * @param {String} key
 * @param {Mixed} val
 */

function pushEncodedKeyValuePair(pairs, key, val) {
  if (Array.isArray(val)) {
    return val.forEach(function(v) {
      pushEncodedKeyValuePair(pairs, key, v);
    });
  }
  pairs.push(encodeURIComponent(key)
    + '=' + encodeURIComponent(val));
}

/**
 * Expose serialization method.
 */

 request.serializeObject = serialize;

 /**
  * Parse the given x-www-form-urlencoded `str`.
  *
  * @param {String} str
  * @return {Object}
  * @api private
  */

function parseString(str) {
  var obj = {};
  var pairs = str.split('&');
  var parts;
  var pair;

  for (var i = 0, len = pairs.length; i < len; ++i) {
    pair = pairs[i];
    parts = pair.split('=');
    obj[decodeURIComponent(parts[0])] = decodeURIComponent(parts[1]);
  }

  return obj;
}

/**
 * Expose parser.
 */

request.parseString = parseString;

/**
 * Default MIME type map.
 *
 *     superagent.types.xml = 'application/xml';
 *
 */

request.types = {
  html: 'text/html',
  json: 'application/json',
  xml: 'application/xml',
  urlencoded: 'application/x-www-form-urlencoded',
  'form': 'application/x-www-form-urlencoded',
  'form-data': 'application/x-www-form-urlencoded'
};

/**
 * Default serialization map.
 *
 *     superagent.serialize['application/xml'] = function(obj){
 *       return 'generated xml here';
 *     };
 *
 */

 request.serialize = {
   'application/x-www-form-urlencoded': serialize,
   'application/json': JSON.stringify
 };

 /**
  * Default parsers.
  *
  *     superagent.parse['application/xml'] = function(str){
  *       return { object parsed from str };
  *     };
  *
  */

request.parse = {
  'application/x-www-form-urlencoded': parseString,
  'application/json': JSON.parse
};

/**
 * Parse the given header `str` into
 * an object containing the mapped fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseHeader(str) {
  var lines = str.split(/\r?\n/);
  var fields = {};
  var index;
  var line;
  var field;
  var val;

  lines.pop(); // trailing CRLF

  for (var i = 0, len = lines.length; i < len; ++i) {
    line = lines[i];
    index = line.indexOf(':');
    field = line.slice(0, index).toLowerCase();
    val = trim(line.slice(index + 1));
    fields[field] = val;
  }

  return fields;
}

/**
 * Check if `mime` is json or has +json structured syntax suffix.
 *
 * @param {String} mime
 * @return {Boolean}
 * @api private
 */

function isJSON(mime) {
  return /[\/+]json\b/.test(mime);
}

/**
 * Return the mime type for the given `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */

function type(str){
  return str.split(/ *; */).shift();
};

/**
 * Return header field parameters.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function params(str){
  return reduce(str.split(/ *; */), function(obj, str){
    var parts = str.split(/ *= */)
      , key = parts.shift()
      , val = parts.shift();

    if (key && val) obj[key] = val;
    return obj;
  }, {});
};

/**
 * Initialize a new `Response` with the given `xhr`.
 *
 *  - set flags (.ok, .error, etc)
 *  - parse header
 *
 * Examples:
 *
 *  Aliasing `superagent` as `request` is nice:
 *
 *      request = superagent;
 *
 *  We can use the promise-like API, or pass callbacks:
 *
 *      request.get('/').end(function(res){});
 *      request.get('/', function(res){});
 *
 *  Sending data can be chained:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' })
 *        .end(function(res){});
 *
 *  Or passed to `.send()`:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' }, function(res){});
 *
 *  Or passed to `.post()`:
 *
 *      request
 *        .post('/user', { name: 'tj' })
 *        .end(function(res){});
 *
 * Or further reduced to a single call for simple cases:
 *
 *      request
 *        .post('/user', { name: 'tj' }, function(res){});
 *
 * @param {XMLHTTPRequest} xhr
 * @param {Object} options
 * @api private
 */

function Response(req, options) {
  options = options || {};
  this.req = req;
  this.xhr = this.req.xhr;
  // responseText is accessible only if responseType is '' or 'text' and on older browsers
  this.text = ((this.req.method !='HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text')) || typeof this.xhr.responseType === 'undefined')
     ? this.xhr.responseText
     : null;
  this.statusText = this.req.xhr.statusText;
  this.setStatusProperties(this.xhr.status);
  this.header = this.headers = parseHeader(this.xhr.getAllResponseHeaders());
  // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
  // getResponseHeader still works. so we get content-type even if getting
  // other headers fails.
  this.header['content-type'] = this.xhr.getResponseHeader('content-type');
  this.setHeaderProperties(this.header);
  this.body = this.req.method != 'HEAD'
    ? this.parseBody(this.text ? this.text : this.xhr.response)
    : null;
}

/**
 * Get case-insensitive `field` value.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

Response.prototype.get = function(field){
  return this.header[field.toLowerCase()];
};

/**
 * Set header related properties:
 *
 *   - `.type` the content type without params
 *
 * A response of "Content-Type: text/plain; charset=utf-8"
 * will provide you with a `.type` of "text/plain".
 *
 * @param {Object} header
 * @api private
 */

Response.prototype.setHeaderProperties = function(header){
  // content-type
  var ct = this.header['content-type'] || '';
  this.type = type(ct);

  // params
  var obj = params(ct);
  for (var key in obj) this[key] = obj[key];
};

/**
 * Parse the given body `str`.
 *
 * Used for auto-parsing of bodies. Parsers
 * are defined on the `superagent.parse` object.
 *
 * @param {String} str
 * @return {Mixed}
 * @api private
 */

Response.prototype.parseBody = function(str){
  var parse = request.parse[this.type];
  if (!parse && isJSON(this.type)) {
    parse = request.parse['application/json'];
  }
  return parse && str && (str.length || str instanceof Object)
    ? parse(str)
    : null;
};

/**
 * Set flags such as `.ok` based on `status`.
 *
 * For example a 2xx response will give you a `.ok` of __true__
 * whereas 5xx will be __false__ and `.error` will be __true__. The
 * `.clientError` and `.serverError` are also available to be more
 * specific, and `.statusType` is the class of error ranging from 1..5
 * sometimes useful for mapping respond colors etc.
 *
 * "sugar" properties are also defined for common cases. Currently providing:
 *
 *   - .noContent
 *   - .badRequest
 *   - .unauthorized
 *   - .notAcceptable
 *   - .notFound
 *
 * @param {Number} status
 * @api private
 */

Response.prototype.setStatusProperties = function(status){
  // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request
  if (status === 1223) {
    status = 204;
  }

  var type = status / 100 | 0;

  // status / class
  this.status = this.statusCode = status;
  this.statusType = type;

  // basics
  this.info = 1 == type;
  this.ok = 2 == type;
  this.clientError = 4 == type;
  this.serverError = 5 == type;
  this.error = (4 == type || 5 == type)
    ? this.toError()
    : false;

  // sugar
  this.accepted = 202 == status;
  this.noContent = 204 == status;
  this.badRequest = 400 == status;
  this.unauthorized = 401 == status;
  this.notAcceptable = 406 == status;
  this.notFound = 404 == status;
  this.forbidden = 403 == status;
};

/**
 * Return an `Error` representative of this response.
 *
 * @return {Error}
 * @api public
 */

Response.prototype.toError = function(){
  var req = this.req;
  var method = req.method;
  var url = req.url;

  var msg = 'cannot ' + method + ' ' + url + ' (' + this.status + ')';
  var err = new Error(msg);
  err.status = this.status;
  err.method = method;
  err.url = url;

  return err;
};

/**
 * Expose `Response`.
 */

request.Response = Response;

/**
 * Initialize a new `Request` with the given `method` and `url`.
 *
 * @param {String} method
 * @param {String} url
 * @api public
 */

function Request(method, url) {
  var self = this;
  this._query = this._query || [];
  this.method = method;
  this.url = url;
  this.header = {}; // preserves header name case
  this._header = {}; // coerces header names to lowercase
  this.on('end', function(){
    var err = null;
    var res = null;

    try {
      res = new Response(self);
    } catch(e) {
      err = new Error('Parser is unable to parse the response');
      err.parse = true;
      err.original = e;
      // issue #675: return the raw response if the response parsing fails
      err.rawResponse = self.xhr && self.xhr.responseText ? self.xhr.responseText : null;
      // issue #876: return the http status code if the response parsing fails
      err.statusCode = self.xhr && self.xhr.status ? self.xhr.status : null;
      return self.callback(err);
    }

    self.emit('response', res);

    if (err) {
      return self.callback(err, res);
    }

    if (res.status >= 200 && res.status < 300) {
      return self.callback(err, res);
    }

    var new_err = new Error(res.statusText || 'Unsuccessful HTTP response');
    new_err.original = err;
    new_err.response = res;
    new_err.status = res.status;

    self.callback(new_err, res);
  });
}

/**
 * Mixin `Emitter` and `requestBase`.
 */

Emitter(Request.prototype);
for (var key in requestBase) {
  Request.prototype[key] = requestBase[key];
}

/**
 * Abort the request, and clear potential timeout.
 *
 * @return {Request}
 * @api public
 */

Request.prototype.abort = function(){
  if (this.aborted) return;
  this.aborted = true;
  this.xhr.abort();
  this.clearTimeout();
  this.emit('abort');
  return this;
};

/**
 * Set Content-Type to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.xml = 'application/xml';
 *
 *      request.post('/')
 *        .type('xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 *      request.post('/')
 *        .type('application/xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 * @param {String} type
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.type = function(type){
  this.set('Content-Type', request.types[type] || type);
  return this;
};

/**
 * Set responseType to `val`. Presently valid responseTypes are 'blob' and 
 * 'arraybuffer'.
 *
 * Examples:
 *
 *      req.get('/')
 *        .responseType('blob')
 *        .end(callback);
 *
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.responseType = function(val){
  this._responseType = val;
  return this;
};

/**
 * Set Accept to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.json = 'application/json';
 *
 *      request.get('/agent')
 *        .accept('json')
 *        .end(callback);
 *
 *      request.get('/agent')
 *        .accept('application/json')
 *        .end(callback);
 *
 * @param {String} accept
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.accept = function(type){
  this.set('Accept', request.types[type] || type);
  return this;
};

/**
 * Set Authorization field value with `user` and `pass`.
 *
 * @param {String} user
 * @param {String} pass
 * @param {Object} options with 'type' property 'auto' or 'basic' (default 'basic')
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.auth = function(user, pass, options){
  if (!options) {
    options = {
      type: 'basic'
    }
  }

  switch (options.type) {
    case 'basic':
      var str = btoa(user + ':' + pass);
      this.set('Authorization', 'Basic ' + str);
    break;

    case 'auto':
      this.username = user;
      this.password = pass;
    break;
  }
  return this;
};

/**
* Add query-string `val`.
*
* Examples:
*
*   request.get('/shoes')
*     .query('size=10')
*     .query({ color: 'blue' })
*
* @param {Object|String} val
* @return {Request} for chaining
* @api public
*/

Request.prototype.query = function(val){
  if ('string' != typeof val) val = serialize(val);
  if (val) this._query.push(val);
  return this;
};

/**
 * Queue the given `file` as an attachment to the specified `field`,
 * with optional `filename`.
 *
 * ``` js
 * request.post('/upload')
 *   .attach(new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
 *   .end(callback);
 * ```
 *
 * @param {String} field
 * @param {Blob|File} file
 * @param {String} filename
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.attach = function(field, file, filename){
  this._getFormData().append(field, file, filename || file.name);
  return this;
};

Request.prototype._getFormData = function(){
  if (!this._formData) {
    this._formData = new root.FormData();
  }
  return this._formData;
};

/**
 * Send `data` as the request body, defaulting the `.type()` to "json" when
 * an object is given.
 *
 * Examples:
 *
 *       // manual json
 *       request.post('/user')
 *         .type('json')
 *         .send('{"name":"tj"}')
 *         .end(callback)
 *
 *       // auto json
 *       request.post('/user')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // manual x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send('name=tj')
 *         .end(callback)
 *
 *       // auto x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // defaults to x-www-form-urlencoded
  *      request.post('/user')
  *        .send('name=tobi')
  *        .send('species=ferret')
  *        .end(callback)
 *
 * @param {String|Object} data
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.send = function(data){
  var obj = isObject(data);
  var type = this._header['content-type'];

  // merge
  if (obj && isObject(this._data)) {
    for (var key in data) {
      this._data[key] = data[key];
    }
  } else if ('string' == typeof data) {
    if (!type) this.type('form');
    type = this._header['content-type'];
    if ('application/x-www-form-urlencoded' == type) {
      this._data = this._data
        ? this._data + '&' + data
        : data;
    } else {
      this._data = (this._data || '') + data;
    }
  } else {
    this._data = data;
  }

  if (!obj || isHost(data)) return this;
  if (!type) this.type('json');
  return this;
};

/**
 * @deprecated
 */
Response.prototype.parse = function serialize(fn){
  if (root.console) {
    console.warn("Client-side parse() method has been renamed to serialize(). This method is not compatible with superagent v2.0");
  }
  this.serialize(fn);
  return this;
};

Response.prototype.serialize = function serialize(fn){
  this._parser = fn;
  return this;
};

/**
 * Invoke the callback with `err` and `res`
 * and handle arity check.
 *
 * @param {Error} err
 * @param {Response} res
 * @api private
 */

Request.prototype.callback = function(err, res){
  var fn = this._callback;
  this.clearTimeout();
  fn(err, res);
};

/**
 * Invoke callback with x-domain error.
 *
 * @api private
 */

Request.prototype.crossDomainError = function(){
  var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
  err.crossDomain = true;

  err.status = this.status;
  err.method = this.method;
  err.url = this.url;

  this.callback(err);
};

/**
 * Invoke callback with timeout error.
 *
 * @api private
 */

Request.prototype.timeoutError = function(){
  var timeout = this._timeout;
  var err = new Error('timeout of ' + timeout + 'ms exceeded');
  err.timeout = timeout;
  this.callback(err);
};

/**
 * Enable transmission of cookies with x-domain requests.
 *
 * Note that for this to work the origin must not be
 * using "Access-Control-Allow-Origin" with a wildcard,
 * and also must set "Access-Control-Allow-Credentials"
 * to "true".
 *
 * @api public
 */

Request.prototype.withCredentials = function(){
  this._withCredentials = true;
  return this;
};

/**
 * Initiate request, invoking callback `fn(res)`
 * with an instanceof `Response`.
 *
 * @param {Function} fn
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.end = function(fn){
  var self = this;
  var xhr = this.xhr = request.getXHR();
  var query = this._query.join('&');
  var timeout = this._timeout;
  var data = this._formData || this._data;

  // store callback
  this._callback = fn || noop;

  // state change
  xhr.onreadystatechange = function(){
    if (4 != xhr.readyState) return;

    // In IE9, reads to any property (e.g. status) off of an aborted XHR will
    // result in the error "Could not complete the operation due to error c00c023f"
    var status;
    try { status = xhr.status } catch(e) { status = 0; }

    if (0 == status) {
      if (self.timedout) return self.timeoutError();
      if (self.aborted) return;
      return self.crossDomainError();
    }
    self.emit('end');
  };

  // progress
  var handleProgress = function(e){
    if (e.total > 0) {
      e.percent = e.loaded / e.total * 100;
    }
    e.direction = 'download';
    self.emit('progress', e);
  };
  if (this.hasListeners('progress')) {
    xhr.onprogress = handleProgress;
  }
  try {
    if (xhr.upload && this.hasListeners('progress')) {
      xhr.upload.onprogress = handleProgress;
    }
  } catch(e) {
    // Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
    // Reported here:
    // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
  }

  // timeout
  if (timeout && !this._timer) {
    this._timer = setTimeout(function(){
      self.timedout = true;
      self.abort();
    }, timeout);
  }

  // querystring
  if (query) {
    query = request.serializeObject(query);
    this.url += ~this.url.indexOf('?')
      ? '&' + query
      : '?' + query;
  }

  // initiate request
  if (this.username && this.password) {
    xhr.open(this.method, this.url, true, this.username, this.password);
  } else {
    xhr.open(this.method, this.url, true);
  }

  // CORS
  if (this._withCredentials) xhr.withCredentials = true;

  // body
  if ('GET' != this.method && 'HEAD' != this.method && 'string' != typeof data && !isHost(data)) {
    // serialize stuff
    var contentType = this._header['content-type'];
    var serialize = this._parser || request.serialize[contentType ? contentType.split(';')[0] : ''];
    if (!serialize && isJSON(contentType)) serialize = request.serialize['application/json'];
    if (serialize) data = serialize(data);
  }

  // set header fields
  for (var field in this.header) {
    if (null == this.header[field]) continue;
    xhr.setRequestHeader(field, this.header[field]);
  }

  if (this._responseType) {
    xhr.responseType = this._responseType;
  }

  // send stuff
  this.emit('request', this);

  // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
  // We need null here if data is undefined
  xhr.send(typeof data !== 'undefined' ? data : null);
  return this;
};


/**
 * Expose `Request`.
 */

request.Request = Request;

/**
 * GET `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} data or fn
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

request.get = function(url, data, fn){
  var req = request('GET', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * HEAD `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} data or fn
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

request.head = function(url, data, fn){
  var req = request('HEAD', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * DELETE `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

function del(url, fn){
  var req = request('DELETE', url);
  if (fn) req.end(fn);
  return req;
};

request['del'] = del;
request['delete'] = del;

/**
 * PATCH `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} data
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

request.patch = function(url, data, fn){
  var req = request('PATCH', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * POST `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} data
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

request.post = function(url, data, fn){
  var req = request('POST', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * PUT `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} data or fn
 * @param {Function} fn
 * @return {Request}
 * @api public
 */

request.put = function(url, data, fn){
  var req = request('PUT', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

},{"./is-object":49,"./request":51,"./request-base":50,"emitter":46,"reduce":47}],49:[function(require,module,exports){
/**
 * Check if `obj` is an object.
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */

function isObject(obj) {
  return null != obj && 'object' == typeof obj;
}

module.exports = isObject;

},{}],50:[function(require,module,exports){
/**
 * Module of mixed-in functions shared between node and client code
 */
var isObject = require('./is-object');

/**
 * Clear previous timeout.
 *
 * @return {Request} for chaining
 * @api public
 */

exports.clearTimeout = function _clearTimeout(){
  this._timeout = 0;
  clearTimeout(this._timer);
  return this;
};

/**
 * Force given parser
 *
 * Sets the body parser no matter type.
 *
 * @param {Function}
 * @api public
 */

exports.parse = function parse(fn){
  this._parser = fn;
  return this;
};

/**
 * Set timeout to `ms`.
 *
 * @param {Number} ms
 * @return {Request} for chaining
 * @api public
 */

exports.timeout = function timeout(ms){
  this._timeout = ms;
  return this;
};

/**
 * Faux promise support
 *
 * @param {Function} fulfill
 * @param {Function} reject
 * @return {Request}
 */

exports.then = function then(fulfill, reject) {
  return this.end(function(err, res) {
    err ? reject(err) : fulfill(res);
  });
}

/**
 * Allow for extension
 */

exports.use = function use(fn) {
  fn(this);
  return this;
}


/**
 * Get request header `field`.
 * Case-insensitive.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

exports.get = function(field){
  return this._header[field.toLowerCase()];
};

/**
 * Get case-insensitive header `field` value.
 * This is a deprecated internal API. Use `.get(field)` instead.
 *
 * (getHeader is no longer used internally by the superagent code base)
 *
 * @param {String} field
 * @return {String}
 * @api private
 * @deprecated
 */

exports.getHeader = exports.get;

/**
 * Set header `field` to `val`, or multiple fields with one object.
 * Case-insensitive.
 *
 * Examples:
 *
 *      req.get('/')
 *        .set('Accept', 'application/json')
 *        .set('X-API-Key', 'foobar')
 *        .end(callback);
 *
 *      req.get('/')
 *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
 *        .end(callback);
 *
 * @param {String|Object} field
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

exports.set = function(field, val){
  if (isObject(field)) {
    for (var key in field) {
      this.set(key, field[key]);
    }
    return this;
  }
  this._header[field.toLowerCase()] = val;
  this.header[field] = val;
  return this;
};

/**
 * Remove header `field`.
 * Case-insensitive.
 *
 * Example:
 *
 *      req.get('/')
 *        .unset('User-Agent')
 *        .end(callback);
 *
 * @param {String} field
 */
exports.unset = function(field){
  delete this._header[field.toLowerCase()];
  delete this.header[field];
  return this;
};

/**
 * Write the field `name` and `val` for "multipart/form-data"
 * request bodies.
 *
 * ``` js
 * request.post('/upload')
 *   .field('foo', 'bar')
 *   .end(callback);
 * ```
 *
 * @param {String} name
 * @param {String|Blob|File|Buffer|fs.ReadStream} val
 * @return {Request} for chaining
 * @api public
 */
exports.field = function(name, val) {
  this._getFormData().append(name, val);
  return this;
};

},{"./is-object":49}],51:[function(require,module,exports){
// The node and browser modules expose versions of this with the
// appropriate constructor function bound as first argument
/**
 * Issue a request:
 *
 * Examples:
 *
 *    request('GET', '/users').end(callback)
 *    request('/users').end(callback)
 *    request('/users', callback)
 *
 * @param {String} method
 * @param {String|Function} url or callback
 * @return {Request}
 * @api public
 */

function request(RequestConstructor, method, url) {
  // callback
  if ('function' == typeof url) {
    return new RequestConstructor('GET', method).end(url);
  }

  // url first
  if (2 == arguments.length) {
    return new RequestConstructor('GET', method);
  }

  return new RequestConstructor(method, url);
}

module.exports = request;

},{}]},{},[1]);
