/*
*/
function UsersCommand(data) {

    Object.defineProperties(this, {
        /*
          The Perforce username.
        */
        "user": {
            value: data ? data.user : undefined,
            enumerable: true,
            writable: true
        },
        /*
          Type of user: standard, operator, or service.

          Once you set the type, you cannot change it.

        */
        "type": {
            value: data ? data.type : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The user’s email address. By default, this is user@client.

        */
        "email": {
            value: data ? data.email : undefined,
            enumerable: true,
            writable: true
        },
        /*
          The date and time this specification was last updated.

        */
        "update": {
            enumerable: true,
            get: function() {
                if (data && data.update) {
                    var strVal = data.update;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The date and time this user last ran a Perforce command.

        */
        "access": {
            enumerable: true,
            get: function() {
                if (data && data.access) {
                    var strVal = data.access;
                    return Date.parse(strVal);
                }
            }
        },
        /*
          The user's full name.
        */
        "fullName": {
            value: data ? data.fullName : undefined,
            enumerable: true,
            writable: true
        },
        /*
          If 'enabled', the password has been set on the user.
        */
        "hasPassword": {
            value: data ? data.hasPassword : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = UsersCommand;
