var assert = require('assert');
var helix_web_services_client = require('../index.js');
var test_methods = require('./util/test_methods');
var string_methods = require('./util/string_methods');

var done = false;

test_methods.clientAsJdoe(function(err, c) {
  if (err) {
    console.log("ERROR", err);
    assert(false);
  }

  var rand = string_methods.randomString();

  var alphaApi = c.createAlphaApi();

  var changelistRequest = new helix_web_services_client.models.ChangelistRequest({
    description: "testing integ",
    actions: [
      new helix_web_services_client.models.ChangelistAction({
        actionType: "branch",
        depotFile: "//depot/test-" + rand + "/Experimental/README",
        fromDepotFile: "//depot/dev/Experimental/README"
      })
    ]
  });

  alphaApi.serverChangesPost("localhost", changelistRequest, function(err, response) {
    if (err) {
      console.log("ERROR", err);
      assert(false);
    }

    assert(response.results.find(function(r) { return !!r.submittedChange; }));
    done = true;
  });
});


function checkForDone() {
  if (!done) {
    setTimeout(checkForDone, 500);
  }
}

setTimeout(checkForDone, 0);
