var assert = require('assert');
var helix_web_services_client = require('../index.js');
var test_methods = require('./util/test_methods');
var string_methods = require('./util/string_methods');

var done = false;

test_methods.clientAsSuper(function (err, c) {
  if (err) {
    console.log("ERROR", err);
    assert(false);
  }

  var api = c.createDefaultApi();

  api.serverProtectionsGet("localhost", function(err, protections) {
    if (err) {
      console.log("ERROR", err);
      assert(false);
    }

    assert(protections.protections.length >= 2);

    protections.protections.push("super user jdoe * //...");

    api.serverProtectionsPut("localhost", protections, function(err) {
      if (err) {
        console.log("ERROR", err);
        assert(false);
      }

      api.serverProtectionsGet("localhost", function (err, updated) {
        if (err) {
          console.log("ERROR", err);
          assert(false);
        }

        assert(updated.protections.find(function (p) {
            return p == "super user jdoe * //...";
          }) != null);
        done = true;
      });
    });
  });
});

function checkForDone() {
  if (!done) {
    setTimeout(checkForDone, 500);
  }
}

setTimeout(checkForDone, 0);
