<?php
/**
 * GitFusionRepoBranchConfig
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * GitFusionRepoBranchConfig Class Doc Comment
 *
 * @category    Class
 * @description Defines a unique Git Fusion branch.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GitFusionRepoBranchConfig implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'git_branch_id' => 'string',
        'git_branch_name' => 'string',
        'view' => 'string[]',
        'stream' => 'string',
        'read_only' => 'string'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'git_branch_id' => 'gitBranchId',
        'git_branch_name' => 'gitBranchName',
        'view' => 'view',
        'stream' => 'stream',
        'read_only' => 'readOnly'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'git_branch_id' => 'setGitBranchId',
        'git_branch_name' => 'setGitBranchName',
        'view' => 'setView',
        'stream' => 'setStream',
        'read_only' => 'setReadOnly'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'git_branch_id' => 'getGitBranchId',
        'git_branch_name' => 'getGitBranchName',
        'view' => 'getView',
        'stream' => 'getStream',
        'read_only' => 'getReadOnly'
    );

    
    /**
      * $git_branch_id Alphanumeric ID for the git branch.\n_Do not change this value once this repo has been cloned_.
      * @var string
      */
    protected $git_branch_id;
    
    /**
      * $git_branch_name Defines a name specified in a local repo for a Git branch.\n\nA valid Git branch name.\nDo not edit this value after you clone the repo.
      * @var string
      */
    protected $git_branch_name;
    
    /**
      * $view Defines a Perforce workspace view mapping that maps Perforce depot paths (left side) to Git work tree paths (right side).\n\nCorrectly formed mapping syntax; must not include any Perforce stream or spec depots, and all depot paths on the right side must match exactly across all branch definitions.\nYou can add and remove only certain types of Perforce branches from this view after you clone the repo.
      * @var string[]
      */
    protected $view;
    
    /**
      * $stream Defines a Perforce stream that maps to the Git branch.\n\nProvide a stream name using the syntax //streamdepot/mystream.\nA Git Fusion branch can be defined as a view or a stream but not both.\nIf your branch is defined as stream, it can include only one stream.
      * @var string
      */
    protected $stream;
    
    /**
      * $read_only Prohibit git pushes that introduce commits to the branch.
      * @var string
      */
    protected $read_only;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["git_branch_id"])) {
              $this->git_branch_id = $data["git_branch_id"];
            }
            if (isset($data["git_branch_name"])) {
              $this->git_branch_name = $data["git_branch_name"];
            }
            if (isset($data["view"])) {
              $this->view = $data["view"];
            }
            if (isset($data["stream"])) {
              $this->stream = $data["stream"];
            }
            if (isset($data["read_only"])) {
              $this->read_only = $data["read_only"];
            }
        }
    }
    
    /**
     * Gets git_branch_id
     * @return string
     */
    public function getGitBranchId()
    {
        return $this->git_branch_id;
    }

    /**
     * Sets git_branch_id
     * @param string $git_branch_id Alphanumeric ID for the git branch.\n_Do not change this value once this repo has been cloned_.
     * @return $this
     */
    public function setGitBranchId($git_branch_id)
    {
        
        $this->git_branch_id = $git_branch_id;
        return $this;
    }
    
    /**
     * Gets git_branch_name
     * @return string
     */
    public function getGitBranchName()
    {
        return $this->git_branch_name;
    }

    /**
     * Sets git_branch_name
     * @param string $git_branch_name Defines a name specified in a local repo for a Git branch.\n\nA valid Git branch name.\nDo not edit this value after you clone the repo.
     * @return $this
     */
    public function setGitBranchName($git_branch_name)
    {
        
        $this->git_branch_name = $git_branch_name;
        return $this;
    }
    
    /**
     * Gets view
     * @return string[]
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Sets view
     * @param string[] $view Defines a Perforce workspace view mapping that maps Perforce depot paths (left side) to Git work tree paths (right side).\n\nCorrectly formed mapping syntax; must not include any Perforce stream or spec depots, and all depot paths on the right side must match exactly across all branch definitions.\nYou can add and remove only certain types of Perforce branches from this view after you clone the repo.
     * @return $this
     */
    public function setView($view)
    {
        
        $this->view = $view;
        return $this;
    }
    
    /**
     * Gets stream
     * @return string
     */
    public function getStream()
    {
        return $this->stream;
    }

    /**
     * Sets stream
     * @param string $stream Defines a Perforce stream that maps to the Git branch.\n\nProvide a stream name using the syntax //streamdepot/mystream.\nA Git Fusion branch can be defined as a view or a stream but not both.\nIf your branch is defined as stream, it can include only one stream.
     * @return $this
     */
    public function setStream($stream)
    {
        
        $this->stream = $stream;
        return $this;
    }
    
    /**
     * Gets read_only
     * @return string
     */
    public function getReadOnly()
    {
        return $this->read_only;
    }

    /**
     * Sets read_only
     * @param string $read_only Prohibit git pushes that introduce commits to the branch.
     * @return $this
     */
    public function setReadOnly($read_only)
    {
        
        $this->read_only = $read_only;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
