<?php
/**
 * Protections
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * Protections Class Doc Comment
 *
 * @category    Class
 * @description Displays the information stored in the `p4 protect` command.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Protections implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'protections' => 'string[]'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'protections' => 'protections'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'protections' => 'setProtections'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'protections' => 'getProtections'
    );

    
    /**
      * $protections Each item in the protections array is a line in the protections table, and is split into five columns.\n\n1. Access level or mode.\nOne of the access levels list, read, open, write, admin, super, review; or one of the rights =read, =open, =write, and =branch,\n\n2. Either `user` or `group`, to indicate what's identified by this entry.\n\n3. The group name or user name.\nTo grant permission to all users, use a wildcard with just an asterix symbol.\n\n4. The IP address of the client host.\n\n5. The depot file path, which can contain wildcards.\nTo exclude this mapping from the permission set, use a dash `-` as the first character of this value.\n\nIPv6 addresses and IPv4 addresses are also supported.\nYou can use the * wildcard to refer to all IP addresses, but only when you are not using CIDR notation.\n\nIf you use the * wildcard with an IPv6 address, you must enclose the entire IPv6 address in square brackets.\nFor example, [2001:db8:1:2:*] is equivalent to [2001:db8:1:2::]/64.\nBest practice is to use CIDR notation, surround IPv6 addresses with brackets, and to avoid the * wildcard.\n\nHow the system forms host addresses depends on the setting of the dm.proxy.protects variable.\nBy default, this variable is set to 1.\nThis means that if the client host uses some intermediary (proxy, broker, replica) to access the server, the proxy- prefix is prepended to the client host address to indicate that the connection is not direct.\nIf you specify proxy-* for the Host field, that will affect all connections made via proxies, brokers, and replicas. A value like proxy-10.0.0.5 identifies a client machine with an IP address of 10.0.0.5 that is connected to the server through an intermediary.\n\nSetting the dm.proxy.protects variable to 0, removes the proxy- prefix and allows you to write a single set of protection entries that apply both to directly-connected clients as well as to those that connect via an intermediary.\nThis is more convenient but less secure if it matters that a connection is made using an intermediary. If you use this setting, all intermediaries must be at release 2012.1 or higher.
      * @var string[]
      */
    protected $protections;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["protections"])) {
              $this->protections = $data["protections"];
            }
        }
    }
    
    /**
     * Gets protections
     * @return string[]
     */
    public function getProtections()
    {
        return $this->protections;
    }

    /**
     * Sets protections
     * @param string[] $protections Each item in the protections array is a line in the protections table, and is split into five columns.\n\n1. Access level or mode.\nOne of the access levels list, read, open, write, admin, super, review; or one of the rights =read, =open, =write, and =branch,\n\n2. Either `user` or `group`, to indicate what's identified by this entry.\n\n3. The group name or user name.\nTo grant permission to all users, use a wildcard with just an asterix symbol.\n\n4. The IP address of the client host.\n\n5. The depot file path, which can contain wildcards.\nTo exclude this mapping from the permission set, use a dash `-` as the first character of this value.\n\nIPv6 addresses and IPv4 addresses are also supported.\nYou can use the * wildcard to refer to all IP addresses, but only when you are not using CIDR notation.\n\nIf you use the * wildcard with an IPv6 address, you must enclose the entire IPv6 address in square brackets.\nFor example, [2001:db8:1:2:*] is equivalent to [2001:db8:1:2::]/64.\nBest practice is to use CIDR notation, surround IPv6 addresses with brackets, and to avoid the * wildcard.\n\nHow the system forms host addresses depends on the setting of the dm.proxy.protects variable.\nBy default, this variable is set to 1.\nThis means that if the client host uses some intermediary (proxy, broker, replica) to access the server, the proxy- prefix is prepended to the client host address to indicate that the connection is not direct.\nIf you specify proxy-* for the Host field, that will affect all connections made via proxies, brokers, and replicas. A value like proxy-10.0.0.5 identifies a client machine with an IP address of 10.0.0.5 that is connected to the server through an intermediary.\n\nSetting the dm.proxy.protects variable to 0, removes the proxy- prefix and allows you to write a single set of protection entries that apply both to directly-connected clients as well as to those that connect via an intermediary.\nThis is more convenient but less secure if it matters that a connection is made using an intermediary. If you use this setting, all intermediaries must be at release 2012.1 or higher.
     * @return $this
     */
    public function setProtections($protections)
    {
        
        $this->protections = $protections;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
