$:.push File.expand_path("../../lib", __FILE__)
require 'helix_web_services_client'

require_relative './util/test_config'
require_relative './util/string_utils'

require 'pp'

api = api_as_super

triggers = api.server_triggers_get('localhost')

original_list = [] + triggers.triggers

lines = []
lines.concat(triggers.triggers)

lines << 'cscheck change-submit //depot/... "cmd %changelist%"'

to_update = HelixWebServices::Triggers.new(
    triggers: lines
)

api.server_triggers_put('localhost', to_update)

updated = api.server_triggers_get('localhost')

unless updated.triggers.include?('cscheck change-submit //depot/... "cmd %changelist%"')
  raise 'did not update triggers'
end

to_clear = HelixWebServices::Triggers.new(
    triggers: original_list
)

api.server_triggers_put('localhost', to_clear)

cleared = api.server_triggers_get('localhost')

if cleared.triggers.include?('cscheck change-submit //depot/... "cmd %changelist%"')
  raise 'did not update triggers again'
end
